(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    199263,       4966]
NotebookOptionsPosition[    198500,       4940]
NotebookOutlinePosition[    198936,       4959]
CellTagsIndexPosition[    198893,       4956]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"<<", "Combinatorica`"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Example", " ", "5.1"}], " ", ":", " ", 
    RowBox[{"1", "-", 
     RowBox[{"dim", " ", 
      RowBox[{"Fibonacci", ".", " ", "Q"}], " ", "must", " ", "be", " ", 
      "given", " ", "in", " ", "1", " ", "by", " ", "1", " ", "matrix", " ", 
      RowBox[{"form", "."}]}]}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Q", "=", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"AlgebraicNumber", "[", 
      RowBox[{
       RowBox[{"Root", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"#", "^", "2"}], "-", "#", "-", "1"}], ",", "2"}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "]"}], "}"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f0", "=", 
   RowBox[{"Function", "[", 
    RowBox[{"z", ",", 
     RowBox[{
      RowBox[{"Q", ".", "z"}], "+", "0"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f1", "=", 
   RowBox[{"Function", "[", 
    RowBox[{"z", ",", 
     RowBox[{
      RowBox[{"Q", ".", "z"}], "+", "1"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"P0", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", "f0", "}"}], ",", 
        RowBox[{"{", "f0", "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", "f1", "}"}], ",", 
        RowBox[{"{", "}"}]}], "}"}]}], "}"}]}], ";"}], " ", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Example", " ", "5.2", " ", 
      RowBox[{"(", "1", ")"}]}], ":", " ", 
     RowBox[{"Baker", "-", "Barge", "-", 
      RowBox[{"Kwapisz", " ", "example"}]}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Q", "=", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"AlgebraicNumber", "[", 
        RowBox[{
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "^", "2"}], "-", 
            RowBox[{"6", "#"}], "+", "1"}], ",", "2"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}], "]"}], "}"}], "}"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"W", "=", 
     RowBox[{"AlgebraicNumber", "[", 
      RowBox[{
       RowBox[{"Root", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"#", "^", "2"}], "-", 
          RowBox[{"6", "#"}], "+", "1"}], ",", "2"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"U", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"W", "-", "1"}], ")"}], "/", "4"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"f0", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", "0"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"f1", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", "1"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"f2", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", "U"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"f3", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", "U", "+", "1"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"f4", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"2", "U"}], "+", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"f5", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"3", "U"}], "+", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"f6", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"4", "U"}], "+", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"P0", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"f0", ",", "f4", ",", "f5", ",", "f6"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"f5", ",", "f6"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"f4", ",", "f5"}], "}"}], ",", " ", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f0", "}"}], ",", 
         RowBox[{"{", "}"}]}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "f3", "}"}], ",", 
         RowBox[{"{", "f4", "}"}], ",", 
         RowBox[{"{", "f3", "}"}], ",", " ", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f3", "}"}], ",", 
         RowBox[{"{", "f1", "}"}]}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f2", "}"}], ",", 
         RowBox[{"{", "f0", "}"}], ",", " ", 
         RowBox[{"{", "f2", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}]}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f0", "}"}], ",", 
         RowBox[{"{", "}"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{"f0", ",", "f4", ",", "f5", ",", "f6"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"f5", ",", "f6"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"f4", ",", "f5"}], "}"}]}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f3", "}"}], ",", 
         RowBox[{"{", "f1", "}"}], ",", " ", 
         RowBox[{"{", "f3", "}"}], ",", 
         RowBox[{"{", "f4", "}"}], ",", 
         RowBox[{"{", "f3", "}"}]}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "f2", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}], ",", " ", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f2", "}"}], ",", 
         RowBox[{"{", "f0", "}"}]}], "}"}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Example", " ", "5.2", " ", 
       RowBox[{"(", "2", ")"}]}], ":", " ", 
      RowBox[{
       RowBox[{"B", ".", " ", "Sing"}], " ", "example"}]}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"W", "=", 
     RowBox[{"AlgebraicNumber", "[", 
      RowBox[{
       RowBox[{"Root", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"#", "^", "2"}], "-", "#", "-", "1"}], ",", "2"}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Q", "=", 
     RowBox[{"{", 
      RowBox[{"{", "W", "}"}], "}"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"f0", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", " ", 
       RowBox[{"Q", ".", "z"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"f1", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", " ", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", "W"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"P0", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "f0", "}"}], ",", 
         RowBox[{"{", "f0", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}]}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f1", "}"}], ",", 
         RowBox[{"{", "}"}]}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f0", "}"}], ",", 
         RowBox[{"{", "f0", "}"}]}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "f1", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}]}], "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Example", " ", "5.3"}], " ", ":", " ", 
      RowBox[{"Example", " ", "7.5", " ", "in", " ", "the", " ", "paper", " ", 
       RowBox[{"of", " ", "[", 
        RowBox[{
         RowBox[{"Solomyak", " ", "'"}], "97"}], "]"}]}]}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Q", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AlgebraicNumber", "[", 
          RowBox[{
           RowBox[{"Root", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "^", "3"}], "+", "#", "+", "1"}], ",", "2"}], 
            "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}]}], "]"}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"AlgebraicNumber", "[", 
          RowBox[{
           RowBox[{"Root", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "^", "3"}], "+", "#", "+", "1"}], ",", "3"}], 
            "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}], "}"}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Map", "[", 
     RowBox[{"Abs", ",", 
      RowBox[{"Q", "//", "N"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"f0", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Q", ".", 
        RowBox[{"(", 
         RowBox[{"z", "+", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}]}], ")"}]}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"f1", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Q", ".", 
        RowBox[{"(", 
         RowBox[{"z", "+", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "1"}], "-", 
             RowBox[{"AlgebraicNumber", "[", 
              RowBox[{
               RowBox[{"Root", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"#", "^", "3"}], "+", "#", "+", "1"}], ",", "2"}], 
                "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}], ",", 
            RowBox[{
             RowBox[{"-", "1"}], "-", 
             RowBox[{"AlgebraicNumber", "[", 
              RowBox[{
               RowBox[{"Root", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"#", "^", "3"}], "+", "#", "+", "1"}], ",", "3"}], 
                "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}]}], "}"}]}], 
         ")"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"f2", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Q", ".", 
        RowBox[{"(", 
         RowBox[{"z", "+", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}]}], "}"}]}], ")"}]}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"P0", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f2", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "f0", "}"}], ",", 
         RowBox[{"{", "f1", "}"}], ",", 
         RowBox[{"{", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f2", "}"}], ",", 
         RowBox[{"{", "}"}]}], "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Example", " ", "5.4"}], " ", ":", " ", 
       RowBox[{"Example", " ", "of", " ", "Figure", " ", "2"}]}], ",", 
      RowBox[{"3", " ", 
       RowBox[{"in", " ", "[", 
        RowBox[{"Kenyon", "-", 
         RowBox[{
          RowBox[{"Solomyak", " ", "'"}], "10"}]}], "]"}]}]}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Q", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AlgebraicNumber", "[", 
          RowBox[{
           RowBox[{"Root", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "^", "3"}], "-", 
              RowBox[{"#", "^", "2"}], "-", 
              RowBox[{"4", "#"}], "+", "3"}], ",", "3"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}]}], "]"}], ",", "0"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"AlgebraicNumber", "[", 
          RowBox[{
           RowBox[{"Root", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "^", "3"}], "-", 
              RowBox[{"#", "^", "2"}], "-", 
              RowBox[{"4", "#"}], "+", "3"}], ",", "1"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}], "}"}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"f0", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Q", ".", 
        RowBox[{"(", 
         RowBox[{"z", "+", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}]}], ")"}]}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"f1", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Q", ".", 
        RowBox[{"(", 
         RowBox[{"z", "+", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}]}], ")"}]}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"f2", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Q", ".", 
        RowBox[{"(", 
         RowBox[{"z", "+", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Q", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"Q", "[", 
             RowBox[{"[", 
              RowBox[{"2", ",", "2"}], "]"}], "]"}]}], "}"}]}], ")"}]}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"f3", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Q", ".", 
        RowBox[{"(", 
         RowBox[{"z", "+", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"2", 
              RowBox[{"Q", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "-", "1"}], ",", 
            RowBox[{
             RowBox[{"2", 
              RowBox[{"Q", "[", 
               RowBox[{"[", 
                RowBox[{"2", ",", "2"}], "]"}], "]"}]}], "-", "1"}]}], 
           "}"}]}], ")"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"f4", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Q", ".", 
        RowBox[{"(", 
         RowBox[{"z", "+", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"3", 
              RowBox[{"Q", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "-", "2"}], ",", 
            RowBox[{
             RowBox[{"3", 
              RowBox[{"Q", "[", 
               RowBox[{"[", 
                RowBox[{"2", ",", "2"}], "]"}], "]"}]}], "-", "2"}]}], 
           "}"}]}], ")"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"P0", "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "f1", "}"}], ",", 
          RowBox[{"{", "f0", "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"f1", ",", "f2", ",", "f3", ",", "f4"}], "}"}], ",", 
          RowBox[{"{", "f0", "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"f2", ",", "f3", ",", "f4"}], "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}]}], "}"}]}], "}"}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Example", " ", "5.5"}], " ", ":", " ", 
      RowBox[{"Domino", " ", "tiling", " ", 
       RowBox[{"in", " ", "[", 
        RowBox[{
         RowBox[{"Solomyak", " ", "'"}], "97"}], "]"}]}]}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Q", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", "2"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "0"}], "}"}]}], "}"}]}], ";", "\n", 
    RowBox[{"f1", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "2"}], ",", "0"}], "}"}]}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"f2", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "2"}], ",", "3"}], "}"}]}]}], "]"}]}], ";", "\n", 
    RowBox[{"f3", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "2"}], ",", "1"}], "}"}]}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"f4", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}], "]"}]}], ";", "\n", 
    RowBox[{"f5", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "3"}], ",", "0"}], "}"}]}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"f6", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "3"}], ",", "1"}], "}"}]}]}], "]"}]}], ";", "\n", 
    RowBox[{"f7", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"f8", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "4"}], ",", "0"}], "}"}]}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"P0", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"f1", ",", "f2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"f5", ",", "f6"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"f3", ",", "f4"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"f7", ",", "f8"}], "}"}]}], "}"}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Example", " ", "5.6", 
       RowBox[{"(", "1", ")"}]}], " ", ":", " ", 
      RowBox[{"Minimal", " ", "Pisot", " ", "case"}]}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Q", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "/", 
          RowBox[{"AlgebraicNumber", "[", 
           RowBox[{
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"#", "^", "3"}], "-", "#", "-", "1"}], ",", "2"}], 
             "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}], ",", "0"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"1", "/", 
          RowBox[{"AlgebraicNumber", "[", 
           RowBox[{
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"#", "^", "3"}], "-", "#", "-", "1"}], ",", "3"}], 
             "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"Map", "[", 
     RowBox[{"Abs", ",", 
      RowBox[{"Q", "//", "N"}]}], "]"}], ";", "\n", 
    RowBox[{"f0", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Q", ".", 
        RowBox[{"(", 
         RowBox[{"z", "+", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}]}], ")"}]}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"f1", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Q", ".", 
        RowBox[{"(", 
         RowBox[{"z", "+", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}]}], ")"}]}]}], "]"}]}], ";", "\n", 
    RowBox[{"P0", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "f0", "}"}], ",", 
         RowBox[{"{", "f0", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f0", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f0", "}"}], ",", 
         RowBox[{"{", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f0", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "f1", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}]}], "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Example", " ", "5.6", 
       RowBox[{"(", "2", ")"}]}], " ", ":", " ", 
      RowBox[{
       RowBox[{"Tetrabonacci", " ", "3"}], "-", 
       RowBox[{"dim", " ", "case"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"In", " ", "3"}], "-", 
       RowBox[{"dim", " ", "or", " ", "higher"}]}], ",", " ", 
      RowBox[{"put", " ", "complex", " ", "number", " ", 
       RowBox[{"(", 
        RowBox[{"if", " ", "exists"}], ")"}], " ", "before", " ", "reals", 
       " ", "for", " ", "a", " ", "planar", " ", "projection", " ", 
       "graphics"}]}], " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"Q", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "/", 
          RowBox[{"AlgebraicNumber", "[", 
           RowBox[{
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"#", "^", "4"}], "-", 
               RowBox[{"#", "^", "3"}], "-", 
               RowBox[{"#", "^", "2"}], "-", "#", "-", "1"}], ",", "3"}], 
             "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}], ",", "0", ",", "0"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"1", "/", 
          RowBox[{"AlgebraicNumber", "[", 
           RowBox[{
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"#", "^", "4"}], "-", 
               RowBox[{"#", "^", "3"}], "-", 
               RowBox[{"#", "^", "2"}], "-", "#", "-", "1"}], ",", "4"}], 
             "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}], ",", "0"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         RowBox[{"1", "/", 
          RowBox[{"AlgebraicNumber", "[", 
           RowBox[{
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"#", "^", "4"}], "-", 
               RowBox[{"#", "^", "3"}], "-", 
               RowBox[{"#", "^", "2"}], "-", "#", "-", "1"}], ",", "1"}], 
             "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"Map", "[", 
     RowBox[{"Abs", ",", 
      RowBox[{"Q", "//", "N"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"f1", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Q", ".", 
        RowBox[{"(", 
         RowBox[{"z", "+", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], ")"}]}]}], "]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"f2", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Q", ".", 
        RowBox[{"(", 
         RowBox[{"z", "+", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ")"}]}]}], "]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"P0", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "f1", "}"}], ",", 
         RowBox[{"{", "f1", "}"}], ",", 
         RowBox[{"{", "f1", "}"}], ",", 
         RowBox[{"{", "f1", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "f2", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f2", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f2", "}"}], ",", 
         RowBox[{"{", "}"}]}], "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Example", " ", "5.7"}], " ", ":", " ", 
      RowBox[{
       RowBox[{"Prop", ".", " ", "6.8"}], " ", 
       RowBox[{"in", " ", "[", 
        RowBox[{"Arnoux", "-", "Furukado", "-", "Harriss", "-", 
         RowBox[{
          RowBox[{"Ito", " ", "'"}], "10"}]}], "]"}]}]}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"lmd1", "=", 
     RowBox[{"AlgebraicNumber", "[", 
      RowBox[{
       RowBox[{"Root", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"#", "^", "4"}], "-", 
          RowBox[{"#", "^", "3"}], "+", "1"}], ",", "1"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"lmd2", "=", 
     RowBox[{"AlgebraicNumber", "[", 
      RowBox[{
       RowBox[{"Root", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"#", "^", "4"}], "-", 
          RowBox[{"#", "^", "3"}], "+", "1"}], ",", "2"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Q", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "/", "lmd1"}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"1", "/", "lmd2"}]}], "}"}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"f0", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Q", ".", 
        RowBox[{"(", 
         RowBox[{"z", "+", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}]}], ")"}]}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"f1", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Q", ".", 
        RowBox[{"(", 
         RowBox[{"z", "+", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"lmd1", "-", 
             RowBox[{"lmd1", "^", "2"}]}], ",", 
            RowBox[{"lmd2", "-", 
             RowBox[{"lmd2", "^", "2"}]}]}], "}"}]}], ")"}]}]}], "]"}]}], ";",
     "\[IndentingNewLine]", 
    RowBox[{"f2", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Q", ".", 
        RowBox[{"(", 
         RowBox[{"z", "+", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"lmd1", "^", "2"}]}], ",", 
            RowBox[{"1", "-", 
             RowBox[{"lmd2", "^", "2"}]}]}], "}"}]}], ")"}]}]}], "]"}]}], ";",
     "\[IndentingNewLine]", 
    RowBox[{"P0", "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "f0", "}"}], ",", 
          RowBox[{"{", "f0", "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "f0", "}"}], ",", 
          RowBox[{"{", "f0", "}"}], ",", 
          RowBox[{"{", "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "f0", "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "f0", "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "f1", "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "f2", "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}]}], "}"}]}], "}"}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Example", " ", "5.8"}], " ", ":", " ", 
      RowBox[{"Penrose", " ", "fractal", " ", "Tiling", " ", 
       RowBox[{"in", " ", "[", 
        RowBox[{"Bandt", "-", 
         RowBox[{
          RowBox[{"Gummelt", " ", "'"}], "97"}]}], "]"}]}]}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Tau", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"Sqrt", "[", "5", "]"}]}], ")"}], "/", "2"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Tau", "=", 
     RowBox[{"ToNumberField", "[", 
      RowBox[{"Tau", ",", 
       RowBox[{"Root", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"#", "^", "8"}], "-", 
           RowBox[{"#", "^", "6"}], "+", 
           RowBox[{"#", "^", "4"}], "-", 
           RowBox[{"#", "^", "2"}], "+", "1"}], "&"}], ",", "1"}], "]"}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"II", "=", 
     RowBox[{"ToNumberField", "[", 
      RowBox[{"I", ",", 
       RowBox[{"Root", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"#", "^", "8"}], "-", 
           RowBox[{"#", "^", "6"}], "+", 
           RowBox[{"#", "^", "4"}], "-", 
           RowBox[{"#", "^", "2"}], "+", "1"}], "&"}], ",", "1"}], "]"}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Zt", "=", 
     RowBox[{"ToNumberField", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"Pi", "/", "5"}], "]"}], "+", 
        RowBox[{"I", " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"Pi", "/", "5"}], "]"}]}]}], ",", 
       RowBox[{"Root", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"#", "^", "8"}], "-", 
           RowBox[{"#", "^", "6"}], "+", 
           RowBox[{"#", "^", "4"}], "-", 
           RowBox[{"#", "^", "2"}], "+", "1"}], "&"}], ",", "1"}], "]"}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Clear", "[", "c", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"f1", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{
         RowBox[{"Exp", "[", 
          RowBox[{"4", "Pi", " ", 
           RowBox[{"I", "/", "5"}]}], "]"}], 
         RowBox[{"z", "/", "Tau"}]}], " ", "+", "c"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"c", "=", 
     RowBox[{"c", "/.", 
      RowBox[{"First", "[", 
       RowBox[{"Solve", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"f1", "[", 
           RowBox[{
            RowBox[{"Tau", "^", "2"}], " ", "I"}], "]"}], "\[Equal]", "I"}], 
         ",", "c"}], "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"c", "=", 
     RowBox[{"ToNumberField", "[", 
      RowBox[{"c", ",", 
       RowBox[{"Root", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"#", "^", "8"}], "-", 
           RowBox[{"#", "^", "6"}], "+", 
           RowBox[{"#", "^", "4"}], "-", 
           RowBox[{"#", "^", "2"}], "+", "1"}], "&"}], ",", "1"}], "]"}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Dm", "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{"Tau", " ", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"RotateRight", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "II", ",", "0", ",", "0", ",", 
                  "0", ",", "II", ",", "0", ",", "0"}], "}"}], ",", "i"}], 
               "]"}], " ", 
              RowBox[{"Zt", "^", "i"}]}], ",", 
             RowBox[{
              RowBox[{"RotateRight", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "c", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", "i"}], 
               "]"}], 
              RowBox[{"Zt", "^", "i"}]}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", "9"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"RotateRight", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "II", ",", "0", ",", "0"}], "}"}], ",", "i"}], 
               "]"}], " ", 
              RowBox[{"Zt", "^", "i"}]}], ",", 
             RowBox[{
              RowBox[{"RotateRight", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "c", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", "i"}], 
               "]"}], 
              RowBox[{"Zt", "^", "i"}]}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", "9"}], "}"}]}], "]"}]}], "]"}]}], 
      "]"}]}], ";", "\n", 
    RowBox[{"(*", " ", 
     RowBox[{
     "Complex", " ", "Conjugation", " ", "within", " ", "the", " ", "same", 
      " ", "AlgebraicNumber", " ", "structure"}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Cj", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"ToNumberField", "[", 
        RowBox[{
         RowBox[{"AlgebraicNumber", "[", 
          RowBox[{
           RowBox[{"Root", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"1", "-", 
               SuperscriptBox["#1", "2"], "+", 
               SuperscriptBox["#1", "4"], "-", 
               SuperscriptBox["#1", "6"], "+", 
               SuperscriptBox["#1", "8"]}], "&"}], ",", "2"}], "]"}], ",", 
           RowBox[{"z", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"Root", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"#", "^", "8"}], "-", 
             RowBox[{"#", "^", "6"}], "+", 
             RowBox[{"#", "^", "4"}], "-", 
             RowBox[{"#", "^", "2"}], "+", "1"}], "&"}], ",", "1"}], "]"}]}], 
        "]"}]}], "]"}]}], ";", "\n", 
    RowBox[{"Dm1", "=", 
     RowBox[{"IdentityMatrix", "[", "20", "]"}]}], ";", "\n", 
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", "1"}], ",", 
      RowBox[{"i", "\[LessEqual]", "20"}], ",", 
      RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"j", "=", "1"}], ",", 
        RowBox[{"j", "\[LessEqual]", "20"}], ",", 
        RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Dm1", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "j"}], "]"}], "]"}], "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Dm", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "j"}], "]"}], "]"}], "\[Equal]", "0"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Dm", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "j"}], "]"}], "]"}], "+", 
                 RowBox[{"Cj", "[", 
                  RowBox[{"Dm", "[", 
                   RowBox[{"[", 
                    RowBox[{"i", ",", "j"}], "]"}], "]"}], "]"}]}], ")"}], 
               "/", "2"}], ",", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Dm", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "j"}], "]"}], "]"}], "-", 
                 RowBox[{"Cj", "[", 
                  RowBox[{"Dm", "[", 
                   RowBox[{"[", 
                    RowBox[{"i", ",", "j"}], "]"}], "]"}], "]"}]}], ")"}], 
               "/", 
               RowBox[{"(", 
                RowBox[{"2", "II"}], ")"}]}]}], "}"}], "}"}]}], "]"}]}]}], 
       "]"}]}], "]"}], ";", "\n", 
    RowBox[{"Q", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Tau", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "Tau"}], "}"}]}], "}"}]}], ";", "\n", 
    RowBox[{"P0", "=", 
     RowBox[{"Dm1", "/.", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", "x__", "}"}], "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"Q", ".", "#"}], "+", 
          RowBox[{"{", "x", "}"}]}], "&"}], "}"}]}]}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Example", " ", "5.9"}], " ", ":", " ", 
      RowBox[{"3", "-", 
       RowBox[{"dim", " ", "chair", " ", "tiling", " ", 
        RowBox[{"in", " ", "[", 
         RowBox[{"Lee", "-", 
          RowBox[{
           RowBox[{"Moody", " ", "'"}], "01"}]}], "]"}]}]}]}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Q", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "2", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "2"}], "}"}]}], "}"}]}], ";", "\n", 
    RowBox[{"f1", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0"}], "}"}]}]}], "]"}]}], ";", "\n", 
    RowBox[{"f2", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0"}], "}"}]}]}], "]"}]}], ";", "\n", 
    RowBox[{"f3", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], "]"}]}], ";", "\n", 
    RowBox[{"f4", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "0"}], "}"}]}]}], "]"}]}], ";", "\n", 
    RowBox[{"f5", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "1"}], "}"}]}]}], "]"}]}], ";", "\n", 
    RowBox[{"f6", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1", ",", "1"}], "}"}]}]}], "]"}]}], ";", "\n", 
    RowBox[{"f7", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "1"}], "}"}]}]}], "]"}]}], ";", "\n", 
    RowBox[{"f8", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "1"}], "}"}]}]}], "]"}]}], ";", "\n", 
    RowBox[{"P0", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"f1", ",", "f5"}], "}"}], ",", 
         RowBox[{"{", "f1", "}"}], ",", 
         RowBox[{"{", "f1", "}"}], ",", 
         RowBox[{"{", "f1", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f1", "}"}], ",", 
         RowBox[{"{", "f1", "}"}], ",", 
         RowBox[{"{", "f1", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "f2", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"f2", ",", "f6"}], "}"}], ",", 
         RowBox[{"{", "f2", "}"}], ",", 
         RowBox[{"{", "f2", "}"}], ",", 
         RowBox[{"{", "f2", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f2", "}"}], ",", 
         RowBox[{"{", "f2", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "f3", "}"}], ",", 
         RowBox[{"{", "f3", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"f3", ",", "f7"}], "}"}], ",", 
         RowBox[{"{", "f3", "}"}], ",", 
         RowBox[{"{", "f3", "}"}], ",", 
         RowBox[{"{", "f3", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f3", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "f4", "}"}], ",", 
         RowBox[{"{", "f4", "}"}], ",", 
         RowBox[{"{", "f4", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"f4", ",", "f8"}], "}"}], ",", 
         RowBox[{"{", "f4", "}"}], ",", 
         RowBox[{"{", "f4", "}"}], ",", 
         RowBox[{"{", "f4", "}"}], ",", 
         RowBox[{"{", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f5", "}"}], ",", 
         RowBox[{"{", "f5", "}"}], ",", 
         RowBox[{"{", "f5", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"f1", ",", "f5"}], "}"}], ",", 
         RowBox[{"{", "f5", "}"}], ",", 
         RowBox[{"{", "f5", "}"}], ",", 
         RowBox[{"{", "f5", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "f6", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f6", "}"}], ",", 
         RowBox[{"{", "f6", "}"}], ",", 
         RowBox[{"{", "f6", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"f2", ",", "f6"}], "}"}], ",", 
         RowBox[{"{", "f6", "}"}], ",", 
         RowBox[{"{", "f6", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "f7", "}"}], ",", 
         RowBox[{"{", "f7", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f7", "}"}], ",", 
         RowBox[{"{", "f7", "}"}], ",", 
         RowBox[{"{", "f7", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"f3", ",", "f7"}], "}"}], ",", 
         RowBox[{"{", "f7", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "f8", "}"}], ",", 
         RowBox[{"{", "f8", "}"}], ",", 
         RowBox[{"{", "f8", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f8", "}"}], ",", 
         RowBox[{"{", "f8", "}"}], ",", 
         RowBox[{"{", "f8", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"f4", ",", "f8"}], "}"}]}], "}"}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Example", " ", "5.10"}], " ", ":", " ", 
      RowBox[{"3", "-", 
       RowBox[{"dim", " ", "Thue"}], "-", 
       RowBox[{"Morse", " ", "tiling"}]}]}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Q", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "2", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "2"}], "}"}]}], "}"}]}], ";", "\n", 
    RowBox[{"f1", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0"}], "}"}]}]}], "]"}]}], ";", "\n", 
    RowBox[{"f2", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0"}], "}"}]}]}], "]"}]}], ";", "\n", 
    RowBox[{"f3", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], "]"}]}], ";", "\n", 
    RowBox[{"f4", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "0"}], "}"}]}]}], "]"}]}], ";", "\n", 
    RowBox[{"f5", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "1"}], "}"}]}]}], "]"}]}], ";", "\n", 
    RowBox[{"f6", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1", ",", "1"}], "}"}]}]}], "]"}]}], ";", "\n", 
    RowBox[{"f7", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "1"}], "}"}]}]}], "]"}]}], ";", "\n", 
    RowBox[{"f8", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{
        RowBox[{"Q", ".", "z"}], "+", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "1"}], "}"}]}]}], "]"}]}], ";", "\n", 
    RowBox[{"P0", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"f1", ",", "f4", ",", "f6", ",", "f7"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"f2", ",", "f3", ",", "f8", ",", "f5"}], "}"}]}], "}"}], 
       ",", "\[IndentingNewLine]", "        ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"f2", ",", "f3", ",", "f5", ",", "f8"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"f1", ",", "f4", ",", "f6", ",", "f7"}], "}"}]}], "}"}]}], 
      "}"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Example", " ", "5.6", 
       RowBox[{"(", "2", ")"}]}], " ", ":", " ", 
      RowBox[{
       RowBox[{"Tetrabonacci", " ", "3"}], "-", 
       RowBox[{"dim", " ", "case"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"In", " ", "3"}], "-", 
       RowBox[{"dim", " ", "or", " ", "higher"}]}], ",", " ", 
      RowBox[{"put", " ", "complex", " ", "number", " ", 
       RowBox[{"(", 
        RowBox[{"if", " ", "exists"}], ")"}], " ", "before", " ", "reals", 
       " ", "for", " ", "a", " ", "planar", " ", "projection", " ", 
       "graphics"}]}], " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"Q", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "/", 
          RowBox[{"AlgebraicNumber", "[", 
           RowBox[{
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"#", "^", "4"}], "-", 
               RowBox[{"#", "^", "3"}], "-", 
               RowBox[{"#", "^", "2"}], "-", "#", "-", "1"}], ",", "3"}], 
             "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}], ",", "0", ",", "0"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"1", "/", 
          RowBox[{"AlgebraicNumber", "[", 
           RowBox[{
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"#", "^", "4"}], "-", 
               RowBox[{"#", "^", "3"}], "-", 
               RowBox[{"#", "^", "2"}], "-", "#", "-", "1"}], ",", "4"}], 
             "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}], ",", "0"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         RowBox[{"1", "/", 
          RowBox[{"AlgebraicNumber", "[", 
           RowBox[{
            RowBox[{"Root", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"#", "^", "4"}], "-", 
               RowBox[{"#", "^", "3"}], "-", 
               RowBox[{"#", "^", "2"}], "-", "#", "-", "1"}], ",", "1"}], 
             "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"Map", "[", 
     RowBox[{"Abs", ",", 
      RowBox[{"Q", "//", "N"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"f1", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Q", ".", 
        RowBox[{"(", 
         RowBox[{"z", "+", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], ")"}]}]}], "]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"f2", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Q", ".", 
        RowBox[{"(", 
         RowBox[{"z", "+", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ")"}]}]}], "]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"P0", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "f1", "}"}], ",", 
         RowBox[{"{", "f1", "}"}], ",", 
         RowBox[{"{", "f1", "}"}], ",", 
         RowBox[{"{", "f1", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "f2", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f2", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", "f2", "}"}], ",", 
         RowBox[{"{", "}"}]}], "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]",
    "*)"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.474088908617284*^9, 3.4740889305620127`*^9}, {
   3.474089658355164*^9, 3.4740897197950706`*^9}, {3.474089845275303*^9, 
   3.4740898780417557`*^9}, {3.4741635286976223`*^9, 3.474163759156497*^9}, {
   3.474272142089034*^9, 3.474272159403861*^9}, {3.475042918182651*^9, 
   3.475042921413987*^9}, {3.475046464614616*^9, 3.475046467104745*^9}, {
   3.475254883574643*^9, 3.475254904467121*^9}, {3.475255015694975*^9, 
   3.4752550571536293`*^9}, {3.4753170799134703`*^9, 3.475317199265299*^9}, {
   3.4753172334012823`*^9, 3.475317358524674*^9}, {3.475317401531005*^9, 
   3.475317651618528*^9}, {3.475317736426931*^9, 3.475317738351663*^9}, {
   3.4753177853266783`*^9, 3.4753178479793243`*^9}, {3.4753179371284733`*^9, 
   3.475317943255937*^9}, {3.475318111011812*^9, 3.475318476083487*^9}, {
   3.475318506956699*^9, 3.475318533462604*^9}, {3.4753185995267973`*^9, 
   3.475318786548195*^9}, 3.475668020099654*^9, {3.4756689873373957`*^9, 
   3.475668993501214*^9}, {3.4756691022395363`*^9, 3.4756691484228277`*^9}, {
   3.47567007182872*^9, 3.475670154643458*^9}, {3.475671854553638*^9, 
   3.475671898233354*^9}, {3.475680704258103*^9, 3.4756807067905483`*^9}, {
   3.475681298477806*^9, 3.47568130038658*^9}, {3.475681333790805*^9, 
   3.475681348914854*^9}, {3.475682041496141*^9, 3.47568204440171*^9}, {
   3.475682395379059*^9, 3.475682448489635*^9}, {3.475682838001359*^9, 
   3.47568284541905*^9}, {3.475682895291806*^9, 3.4756829014250298`*^9}, {
   3.4756835129184504`*^9, 3.4756835190676327`*^9}, {3.475683661594532*^9, 
   3.475683665108842*^9}, {3.475683861590361*^9, 3.47568389001283*^9}, {
   3.4756840322171373`*^9, 3.4756840372960463`*^9}, {3.4756854675078697`*^9, 
   3.475685470797612*^9}, {3.475685781799308*^9, 3.475685787204969*^9}, {
   3.475685903535047*^9, 3.4756859087805767`*^9}, 3.476790506505582*^9, {
   3.476790593426433*^9, 3.4767906258556633`*^9}, {3.4767908556090517`*^9, 
   3.476790915174155*^9}, {3.476790968024768*^9, 3.476790986742021*^9}, {
   3.476791070774568*^9, 3.47679110569419*^9}, {3.476791206376417*^9, 
   3.476791270309*^9}, {3.476791308460001*^9, 3.476791352689073*^9}, {
   3.47679256733667*^9, 3.476792612411787*^9}, 3.47679264450343*^9, {
   3.4767938429343987`*^9, 3.476793843543591*^9}, {3.476793989174246*^9, 
   3.476793990315522*^9}, {3.47679572725651*^9, 3.476795730109583*^9}, {
   3.476795805506671*^9, 3.47679582197945*^9}, {3.476795992398129*^9, 
   3.4767960092534523`*^9}, {3.4767960620529413`*^9, 3.476796071680861*^9}, {
   3.476796227184114*^9, 3.47679623775878*^9}, {3.476796479017304*^9, 
   3.476796485244445*^9}, {3.476796546126347*^9, 3.4767965759482183`*^9}, {
   3.476796687615744*^9, 3.476796869916047*^9}, 3.476796953448241*^9, {
   3.4767989435880404`*^9, 3.47679898440902*^9}, {3.476799448550571*^9, 
   3.476799454457489*^9}, 3.4768081587938013`*^9, {3.476808191935524*^9, 
   3.4768081958271313`*^9}, 3.476808312215228*^9, {3.476810467341508*^9, 
   3.4768104760936327`*^9}, {3.476810691504703*^9, 3.4768107070717382`*^9}, 
   3.4768555123946238`*^9, {3.476856014598378*^9, 3.476856027735775*^9}, {
   3.476858294946039*^9, 3.476858297204433*^9}, {3.476967859882217*^9, 
   3.4769678835877733`*^9}, {3.476968317190411*^9, 3.4769683258947353`*^9}, {
   3.476968447150278*^9, 3.476968447564068*^9}, {3.4769707738446293`*^9, 
   3.4769707996025553`*^9}, 3.477089304184712*^9, {3.477089963821226*^9, 
   3.477090023987135*^9}, {3.477090119050045*^9, 3.477090150368054*^9}, {
   3.47709020216897*^9, 3.477090206416108*^9}, {3.4770902591048403`*^9, 
   3.477090291608451*^9}, {3.477090399238679*^9, 3.477090465251609*^9}, {
   3.4770905501268*^9, 3.477090559661631*^9}, {3.477090612018401*^9, 
   3.477090735885434*^9}, {3.477090814553059*^9, 3.477090818916932*^9}, {
   3.477091001224908*^9, 3.477091084814866*^9}, {3.4770915902957363`*^9, 
   3.4770917606395617`*^9}, {3.4771095136716833`*^9, 
   3.4771095214669228`*^9}, {3.477109642794795*^9, 3.477109689490555*^9}, {
   3.477109895569553*^9, 3.477109908254321*^9}, {3.4771113552632513`*^9, 
   3.4771113610027857`*^9}, {3.477111641659432*^9, 3.4771116452024317`*^9}, {
   3.477111735749465*^9, 3.477111757266395*^9}, {3.4771119366418047`*^9, 
   3.477112016717514*^9}, {3.477112380315874*^9, 3.477112410808321*^9}, {
   3.4771137566718082`*^9, 3.4771137738259487`*^9}, {3.4771140040904207`*^9, 
   3.477114037301383*^9}, {3.4772071871075687`*^9, 3.477207220004415*^9}, {
   3.477289564549917*^9, 3.477289610557193*^9}, 3.477294766679288*^9, {
   3.477297485918042*^9, 3.477297488770396*^9}, {3.4772975609264727`*^9, 
   3.477297563300296*^9}, 3.477299646946447*^9, {3.477343808156139*^9, 
   3.477343832831038*^9}, {3.4773566355789127`*^9, 3.477356655495257*^9}, {
   3.4773566951549807`*^9, 3.4773566953531723`*^9}, {3.4773705155020237`*^9, 
   3.4773705411119957`*^9}, {3.477370924847599*^9, 3.4773709516025963`*^9}, {
   3.477371033964199*^9, 3.4773710604534903`*^9}, {3.4773711796014023`*^9, 
   3.477371182438929*^9}, {3.4846213896804*^9, 3.484621400511505*^9}, {
   3.484621443246467*^9, 3.484621472541469*^9}, {3.484623821503488*^9, 
   3.48462383539883*^9}, {3.484640701362174*^9, 3.4846407588663*^9}, {
   3.484646176544793*^9, 3.4846462746482773`*^9}, {3.484863209487028*^9, 
   3.484863212294489*^9}, {3.48486326734356*^9, 3.4848632700699043`*^9}, {
   3.48486330135117*^9, 3.484863314519932*^9}, {3.4848635256348667`*^9, 
   3.484863546843203*^9}, {3.484865667357533*^9, 3.484865697184564*^9}, {
   3.484867182775708*^9, 3.4848672004148283`*^9}, {3.484876122382012*^9, 
   3.48487615600292*^9}, {3.48487695483318*^9, 3.484877015456353*^9}, {
   3.484877751521214*^9, 3.484877776625774*^9}, {3.48487849998635*^9, 
   3.4848785232771797`*^9}, {3.4848881194574203`*^9, 3.484888158361567*^9}, {
   3.484899784994466*^9, 3.484899809278599*^9}, {3.484901995472146*^9, 
   3.484902026426152*^9}, {3.4849030247659407`*^9, 3.484903043881172*^9}, {
   3.484903652359562*^9, 3.484903675577886*^9}, {3.4850798664941874`*^9, 
   3.485079905052499*^9}, {3.485161069659849*^9, 3.485161090489661*^9}, {
   3.485161177189666*^9, 3.485161191339305*^9}, {3.485161223698554*^9, 
   3.485161256414422*^9}, {3.4851613020390043`*^9, 3.4851614147303143`*^9}, {
   3.4851614662183313`*^9, 3.4851614664300127`*^9}, 3.48516269092828*^9, {
   3.4851627252183847`*^9, 3.485162837944559*^9}, {3.485162899094653*^9, 
   3.485163310992399*^9}, {3.485163353487953*^9, 3.48516335958602*^9}, 
   3.485163619133225*^9, {3.4851638607051573`*^9, 3.485163864157762*^9}, {
   3.485164973158555*^9, 3.485165003968308*^9}, {3.485165159123239*^9, 
   3.485165190803989*^9}, {3.485165239448152*^9, 3.48516524115436*^9}, {
   3.485165317599617*^9, 3.485165572961383*^9}, {3.485165907432415*^9, 
   3.485165935083008*^9}, 3.4851670789174137`*^9, {3.485167148111433*^9, 
   3.485167237162685*^9}, {3.485167295450644*^9, 3.485167343633915*^9}, {
   3.485167466662372*^9, 3.485167470986951*^9}, {3.485167586210338*^9, 
   3.48516761145927*^9}, {3.48516768556542*^9, 3.4851677026988373`*^9}, {
   3.485167764859933*^9, 3.485167771408204*^9}, {3.485167942767685*^9, 
   3.485167951135413*^9}, {3.4851680847803783`*^9, 3.4851680877059307`*^9}, {
   3.485168129495742*^9, 3.4851681297208643`*^9}, {3.485169595223352*^9, 
   3.485169602712895*^9}, {3.485169666531158*^9, 3.485169684618081*^9}, {
   3.485303563989444*^9, 3.485303583870638*^9}, {3.4853036867149143`*^9, 
   3.485303698200325*^9}, {3.4853080364894943`*^9, 3.4853083422993097`*^9}, {
   3.48531188629714*^9, 3.485311901807188*^9}, {3.485311951514974*^9, 
   3.485311951771803*^9}, {3.48531244624446*^9, 3.485312455367691*^9}, {
   3.4856601264281607`*^9, 3.485660126871505*^9}, {3.485660290528594*^9, 
   3.4856603591903343`*^9}, {3.485660438047268*^9, 3.485660459775475*^9}, {
   3.49292676778767*^9, 3.492926773250286*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Set", " ", "parameters", " ", "and", " ", "check", " ", "fundamantal", 
    " ", "necessary", " ", "conditions"}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"sz", "=", 
     RowBox[{"Length", "[", "Q", "]"}]}], ";"}], " ", 
   RowBox[{"(*", " ", 
    RowBox[{"Size", " ", "of", " ", "Expanding", " ", "Matrix"}], " ", "*)"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"dg", "=", 
     RowBox[{"Length", "[", "P0", "]"}]}], ";"}], " ", 
   RowBox[{"(*", " ", 
    RowBox[{"Size", " ", "of", " ", "Substitution", " ", "Matrix"}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"A1", "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{"Map", "[", 
       RowBox[{"Length", ",", "P0", ",", 
        RowBox[{"{", "2", "}"}]}], "]"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Eg", "=", 
     RowBox[{"Sort", "[", 
      RowBox[{
       RowBox[{"Eigenvalues", "[", "A1", "]"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"N", "[", 
          RowBox[{"Abs", "[", "#1", "]"}], "]"}], "<", 
         RowBox[{"N", "[", 
          RowBox[{"Abs", "[", "#2", "]"}], "]"}]}], "&"}]}], "]"}]}], ";"}], 
   "\n", 
   RowBox[{
    RowBox[{"PF", "=", 
     RowBox[{"Abs", "[", 
      RowBox[{"Last", "[", "Eg", "]"}], "]"}]}], ";"}], "\n", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Find", " ", "the", " ", "polynomial", " ", "which", " ", "corresponds", 
     " ", "to", " ", "the", " ", "Perron", " ", "Frobenius", " ", "root"}], 
    "*)"}], "\n", 
   RowBox[{
    RowBox[{"Flist", "=", 
     RowBox[{"Map", "[", 
      RowBox[{"First", ",", 
       RowBox[{"FactorList", "[", 
        RowBox[{"CharacteristicPolynomial", "[", 
         RowBox[{"A1", ",", "x"}], "]"}], "]"}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Flist", "=", 
     RowBox[{"Delete", "[", 
      RowBox[{"Flist", ",", 
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"Map", "[", 
          RowBox[{"NumberQ", ",", "Flist"}], "]"}], ",", "True"}], "]"}]}], 
      "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"FlistSol", "=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Max", "[", 
         RowBox[{"Abs", "[", "#", "]"}], "]"}], "&"}], ",", 
       RowBox[{"x", "/.", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"z", ",", 
            RowBox[{"NSolve", "[", 
             RowBox[{"z", ",", "x"}], "]"}]}], "]"}], ",", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"#", "\[Equal]", "0"}], "&"}], ",", "Flist"}], "]"}]}], 
         "]"}]}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Fd", "=", 
     RowBox[{"First", "[", 
      RowBox[{"Extract", "[", 
       RowBox[{"Flist", ",", 
        RowBox[{"Position", "[", 
         RowBox[{"FlistSol", ",", 
          RowBox[{"Max", "[", "FlistSol", "]"}]}], "]"}]}], "]"}], "]"}]}], 
    ";"}], "\n", "\[IndentingNewLine]", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"Graphics", "[", 
      RowBox[{"Circle", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0"}], "}"}], ",", "1"}], "]"}], "]"}], ",", 
     RowBox[{"Map", "[", 
      RowBox[{"Graphics", ",", 
       RowBox[{"Map", "[", 
        RowBox[{"Point", ",", 
         RowBox[{"FullSimplify", "[", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Re", "[", "#", "]"}], ",", 
               RowBox[{"Im", "[", "#", "]"}]}], "}"}], "&"}], ",", "Eg"}], 
           "]"}], "]"}]}], "]"}]}], "]"}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "Automatic"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Eg0", "=", 
     RowBox[{"Sort", "[", 
      RowBox[{
       RowBox[{"x", "/.", 
        RowBox[{"NSolve", "[", 
         RowBox[{
          RowBox[{"Fd", "\[Equal]", "0"}], ",", "x"}], "]"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"N", "[", 
          RowBox[{"Abs", "[", "#1", "]"}], "]"}], "<", 
         RowBox[{"N", "[", 
          RowBox[{"Abs", "[", "#2", "]"}], "]"}]}], "&"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"Or", "[", 
       RowBox[{
        RowBox[{"PF", "\[LessEqual]", "1"}], ",", 
        RowBox[{
         RowBox[{"Abs", "[", 
          RowBox[{
           RowBox[{"Abs", "[", 
            RowBox[{"Det", "[", 
             RowBox[{"Q", "//", "N"}], "]"}], "]"}], "-", "PF"}], "]"}], ">=", 
         RowBox[{"1000", "$MachineEpsilon"}]}]}], "]"}], ",", 
      RowBox[{
       RowBox[{
       "Print", "[", "\"\<Lagarias-Wang PF conditition : No\>\"", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Interrupt", "[", "]"}]}], ",", 
      RowBox[{
      "Print", "[", "\"\<Lagarias-Wang PF conditition : fulfiled\>\"", 
       "]"}]}], "]"}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.474088908617284*^9, 3.4740889305620127`*^9}, {
   3.474089658355164*^9, 3.4740897197950706`*^9}, {3.474089845275303*^9, 
   3.4740898780417557`*^9}, {3.4741635286976223`*^9, 3.474163759156497*^9}, {
   3.474272142089034*^9, 3.474272159403861*^9}, {3.475042918182651*^9, 
   3.475042921413987*^9}, {3.475046464614616*^9, 3.475046467104745*^9}, {
   3.475254883574643*^9, 3.475254904467121*^9}, {3.475255015694975*^9, 
   3.4752550571536293`*^9}, {3.4753170799134703`*^9, 3.475317199265299*^9}, {
   3.4753172334012823`*^9, 3.475317358524674*^9}, {3.475317401531005*^9, 
   3.475317651618528*^9}, {3.475317736426931*^9, 3.475317738351663*^9}, {
   3.4753177853266783`*^9, 3.4753178479793243`*^9}, {3.4753179371284733`*^9, 
   3.475317943255937*^9}, {3.475318111011812*^9, 3.475318476083487*^9}, {
   3.475318506956699*^9, 3.475318533462604*^9}, {3.4753185995267973`*^9, 
   3.475318786548195*^9}, 3.475668020099654*^9, {3.4756689873373957`*^9, 
   3.475668993501214*^9}, {3.4756691022395363`*^9, 3.4756691484228277`*^9}, {
   3.47567007182872*^9, 3.475670154643458*^9}, {3.475671854553638*^9, 
   3.475671898233354*^9}, {3.475680704258103*^9, 3.4756807067905483`*^9}, {
   3.475681298477806*^9, 3.47568130038658*^9}, {3.475681333790805*^9, 
   3.475681348914854*^9}, {3.475682041496141*^9, 3.47568204440171*^9}, {
   3.475682395379059*^9, 3.475682448489635*^9}, {3.475682838001359*^9, 
   3.47568284541905*^9}, {3.475682895291806*^9, 3.4756829014250298`*^9}, {
   3.4756835129184504`*^9, 3.4756835190676327`*^9}, {3.475683661594532*^9, 
   3.475683665108842*^9}, {3.475683861590361*^9, 3.47568389001283*^9}, {
   3.4756840322171373`*^9, 3.4756840372960463`*^9}, {3.4756854675078697`*^9, 
   3.475685470797612*^9}, {3.475685781799308*^9, 3.475685787204969*^9}, {
   3.475685903535047*^9, 3.4756859087805767`*^9}, 3.476790506505582*^9, {
   3.476790593426433*^9, 3.4767906258556633`*^9}, {3.4767908556090517`*^9, 
   3.476790915174155*^9}, {3.476790968024768*^9, 3.476790986742021*^9}, {
   3.476791070774568*^9, 3.47679110569419*^9}, {3.476791206376417*^9, 
   3.476791270309*^9}, {3.476791308460001*^9, 3.476791352689073*^9}, {
   3.47679256733667*^9, 3.476792612411787*^9}, 3.47679264450343*^9, {
   3.4767938429343987`*^9, 3.476793843543591*^9}, {3.476793989174246*^9, 
   3.476793990315522*^9}, {3.47679572725651*^9, 3.476795730109583*^9}, {
   3.476795805506671*^9, 3.47679582197945*^9}, {3.476795992398129*^9, 
   3.4767960092534523`*^9}, {3.4767960620529413`*^9, 3.476796071680861*^9}, {
   3.476796227184114*^9, 3.47679623775878*^9}, {3.476796479017304*^9, 
   3.476796485244445*^9}, {3.476796546126347*^9, 3.4767965759482183`*^9}, {
   3.476796687615744*^9, 3.476796869916047*^9}, 3.476796953448241*^9, {
   3.4767989435880404`*^9, 3.47679898440902*^9}, {3.476799448550571*^9, 
   3.476799454457489*^9}, 3.4768081587938013`*^9, {3.476808191935524*^9, 
   3.4768081958271313`*^9}, {3.476808312215228*^9, 3.4768083325902348`*^9}, 
   3.476858300527145*^9, {3.476967987565012*^9, 3.476968005401825*^9}, {
   3.484888480213417*^9, 3.484888489313674*^9}, 3.485303019771799*^9, 
   3.4853030906286497`*^9, {3.4928532952234163`*^9, 3.492853306296627*^9}, 
   3.4928533831549377`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Check", " ", "Pisot", " ", "Family", " ", "condition"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"EigenQ", "=", 
     RowBox[{"Eigenvalues", "[", "Q", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"EigenQ", "=", 
     RowBox[{"Eigenvalues", "[", "Q", "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"EigenQ", "=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{"Function", "[", 
        RowBox[{"z", ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"NumberQ", "[", "z", "]"}], ",", "z", ",", 
           RowBox[{"AlgebraicNumber", "[", 
            RowBox[{
             RowBox[{"Root", "[", 
              RowBox[{
               RowBox[{"MinimalPolynomial", "[", "z", "]"}], ",", 
               RowBox[{"First", "[", 
                RowBox[{"First", "[", 
                 RowBox[{"Position", "[", 
                  RowBox[{
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"z", "-", 
                    RowBox[{"AlgebraicNumber", "[", 
                    RowBox[{
                    RowBox[{"Root", "[", 
                    RowBox[{
                    RowBox[{"MinimalPolynomial", "[", "z", "]"}], ",", "i"}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}], ")"}], "//", 
                    "N"}], "]"}], "<", 
                    RowBox[{"1000", "*", "$MachineEpsilon"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{
                    RowBox[{"Length", "[", 
                    RowBox[{"CoefficientList", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MinimalPolynomial", "[", "z", "]"}], "[", "x", 
                    "]"}], ",", "x"}], "]"}], "]"}], "-", "1"}]}], "}"}]}], 
                    "]"}], ",", "True"}], "]"}], "]"}], "]"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}], "]"}]}], "]"}], ",", 
       "\[IndentingNewLine]", "EigenQ"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"AlgSol", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", "1"}], ",", 
      RowBox[{"i", "\[LessEqual]", 
       RowBox[{"Length", "[", "EigenQ", "]"}]}], ",", 
      RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"NumberQ", "[", 
         RowBox[{"EigenQ", "[", 
          RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
        RowBox[{"AlgSol", "=", 
         RowBox[{"Union", "[", 
          RowBox[{"AlgSol", ",", 
           RowBox[{"{", 
            RowBox[{"EigenQ", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "}"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"AlgSol", "=", 
         RowBox[{"Union", "[", 
          RowBox[{"AlgSol", ",", 
           RowBox[{"Map", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"AlgebraicNumber", "[", 
               RowBox[{
                RowBox[{"Root", "[", 
                 RowBox[{
                  RowBox[{"MinimalPolynomial", "[", 
                   RowBox[{"First", "[", 
                    RowBox[{"EigenQ", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", "#"}], 
                 "]"}], ",", 
                RowBox[{"EigenQ", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "]"}], "&"}], ",", 
             RowBox[{"Range", "[", 
              RowBox[{
               RowBox[{"Length", "[", 
                RowBox[{
                 RowBox[{"EigenQ", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "]"}], "-", "1"}], "]"}]}], 
            "]"}]}], "]"}]}]}], "]"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"AlgSol", "=", 
     RowBox[{"Extract", "[", 
      RowBox[{"AlgSol", ",", 
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"AlgSol", "//", "N"}], ",", 
         RowBox[{"x_", "/;", 
          RowBox[{
           RowBox[{"Abs", "[", "x", "]"}], ">", "1"}]}]}], "]"}]}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Complement", "[", 
        RowBox[{"AlgSol", ",", "EigenQ"}], "]"}], "\[Equal]", 
       RowBox[{"{", "}"}]}], ",", " ", "\[IndentingNewLine]", 
      RowBox[{
      "Print", "[", "\"\<Pisot family condition : fulfiled\>\"", "]"}], ",", 
      " ", 
      RowBox[{
       RowBox[{"Print", "[", "\"\<Pisot family condition : No\>\"", "]"}], 
       ";", 
       RowBox[{"Interrupt", "[", "]"}], ";"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Side", " ", "information", " ", "for", " ", "1"}], "-", 
     RowBox[{"dim", " ", "case"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "Eg0", "]"}], "<", 
       RowBox[{"Length", "[", "Eg", "]"}]}], ",", 
      RowBox[{
      "Print", "[", "\"\<Reducible characteristic polynomial\>\"", "]"}]}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "Eg0", "]"}], "\[Equal]", "1"}], "||", 
       RowBox[{"1", ">", 
        RowBox[{"Max", "[", 
         RowBox[{"Abs", "[", 
          RowBox[{"Drop", "[", 
           RowBox[{"Eg0", ",", 
            RowBox[{"-", "1"}]}], "]"}], "]"}], "]"}]}]}], ",", 
      RowBox[{"Print", "[", "\"\<Dominant root : Pisot\>\"", "]"}], ",", 
      RowBox[{
       RowBox[{"Print", "[", "\"\<Dominant root : Non Pisot\>\"", "]"}], 
       ";"}]}], "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"NonIrred", "=", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Diameter", "[", 
          RowBox[{"FromAdjacencyMatrix", "[", 
           RowBox[{"A1", ",", 
            RowBox[{"Type", "\[Rule]", "Directed"}]}], "]"}], "]"}], 
         "\[Equal]", "\[Infinity]"}], ")"}]}], ",", 
      RowBox[{
       RowBox[{
       "Print", "[", "\"\<Substitution rule: Not irreducible\>\"", "]"}], ";", 
       RowBox[{"Interrupt", "[", "]"}], ";"}], ",", 
      RowBox[{"Print", "[", "\"\<Substitution rule: Irreducible\>\"", "]"}]}],
      "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"NonIrred", "||", 
       RowBox[{
        RowBox[{"Abs", "[", 
         RowBox[{
          RowBox[{"Abs", "[", 
           RowBox[{"Eg", "[", 
            RowBox[{"[", 
             RowBox[{"-", "1"}], "]"}], "]"}], "]"}], "-", 
          RowBox[{"Abs", "[", 
           RowBox[{"Eg", "[", 
            RowBox[{"[", 
             RowBox[{"-", "2"}], "]"}], "]"}], "]"}]}], "]"}], "<", 
        RowBox[{"100", " ", "$MachineEpsilon"}]}]}], ",", 
      RowBox[{
       RowBox[{
       "Print", "[", "\"\<Substitution rule: Not primitive\>\"", "]"}], ";", 
       RowBox[{"Interrupt", "[", "]"}], ";"}], ",", 
      RowBox[{"Print", "[", "\"\<Substitution rule: Primitive\>\"", "]"}]}], 
     "]"}], ";"}], "\n"}]}]], "Input",
 CellChangeTimes->{{3.474088908617284*^9, 3.4740889305620127`*^9}, {
   3.474089658355164*^9, 3.4740897197950706`*^9}, {3.474089845275303*^9, 
   3.4740898780417557`*^9}, {3.4741635286976223`*^9, 3.474163759156497*^9}, {
   3.474272142089034*^9, 3.474272159403861*^9}, {3.475042918182651*^9, 
   3.475042921413987*^9}, {3.475046464614616*^9, 3.475046467104745*^9}, {
   3.475254883574643*^9, 3.475254904467121*^9}, {3.475255015694975*^9, 
   3.4752550571536293`*^9}, {3.4753170799134703`*^9, 3.475317199265299*^9}, {
   3.4753172334012823`*^9, 3.475317358524674*^9}, {3.475317401531005*^9, 
   3.475317651618528*^9}, {3.475317736426931*^9, 3.475317738351663*^9}, {
   3.4753177853266783`*^9, 3.4753178479793243`*^9}, {3.4753179371284733`*^9, 
   3.475317943255937*^9}, {3.475318111011812*^9, 3.475318476083487*^9}, {
   3.475318506956699*^9, 3.475318533462604*^9}, {3.4753185995267973`*^9, 
   3.475318786548195*^9}, 3.475668020099654*^9, {3.4756689873373957`*^9, 
   3.475668993501214*^9}, {3.4756691022395363`*^9, 3.4756691484228277`*^9}, {
   3.47567007182872*^9, 3.475670154643458*^9}, {3.475671854553638*^9, 
   3.475671898233354*^9}, {3.475680704258103*^9, 3.4756807067905483`*^9}, {
   3.475681298477806*^9, 3.47568130038658*^9}, {3.475681333790805*^9, 
   3.475681348914854*^9}, {3.475682041496141*^9, 3.47568204440171*^9}, {
   3.475682395379059*^9, 3.475682448489635*^9}, {3.475682838001359*^9, 
   3.47568284541905*^9}, {3.475682895291806*^9, 3.4756829014250298`*^9}, {
   3.4756835129184504`*^9, 3.4756835190676327`*^9}, {3.475683661594532*^9, 
   3.475683665108842*^9}, {3.475683861590361*^9, 3.47568389001283*^9}, {
   3.4756840322171373`*^9, 3.4756840372960463`*^9}, {3.4756854675078697`*^9, 
   3.475685470797612*^9}, {3.475685781799308*^9, 3.475685787204969*^9}, {
   3.475685903535047*^9, 3.4756859087805767`*^9}, 3.476790506505582*^9, {
   3.476790593426433*^9, 3.4767906258556633`*^9}, {3.4767908556090517`*^9, 
   3.476790915174155*^9}, {3.476790968024768*^9, 3.476790986742021*^9}, {
   3.476791070774568*^9, 3.47679110569419*^9}, {3.476791206376417*^9, 
   3.476791270309*^9}, {3.476791308460001*^9, 3.476791352689073*^9}, {
   3.47679256733667*^9, 3.476792612411787*^9}, 3.47679264450343*^9, {
   3.4767938429343987`*^9, 3.476793843543591*^9}, {3.476793989174246*^9, 
   3.476793990315522*^9}, {3.47679572725651*^9, 3.476795730109583*^9}, {
   3.476795805506671*^9, 3.47679582197945*^9}, {3.476795992398129*^9, 
   3.4767960092534523`*^9}, {3.4767960620529413`*^9, 3.476796071680861*^9}, {
   3.476796227184114*^9, 3.47679623775878*^9}, {3.476796479017304*^9, 
   3.476796485244445*^9}, {3.476796546126347*^9, 3.4767965759482183`*^9}, {
   3.476796687615744*^9, 3.476796869916047*^9}, 3.476796953448241*^9, {
   3.4767989435880404`*^9, 3.47679898440902*^9}, {3.476799448550571*^9, 
   3.476799454457489*^9}, 3.4768081587938013`*^9, {3.476808191935524*^9, 
   3.4768081958271313`*^9}, {3.476808312215228*^9, 3.4768083325902348`*^9}, 
   3.476858300527145*^9, {3.476967987565012*^9, 3.476968005401825*^9}, {
   3.484621569376485*^9, 3.4846216004345703`*^9}, {3.484621632396555*^9, 
   3.48462169231999*^9}, {3.4846218018575573`*^9, 3.4846218211047907`*^9}, {
   3.4846222456494417`*^9, 3.484622262010755*^9}, {3.484863903508047*^9, 
   3.484863910613323*^9}, {3.485660159556094*^9, 3.4856601836907988`*^9}, 
   3.492853416681425*^9, {3.4928534564366083`*^9, 3.492853481270015*^9}, {
   3.4929268186308002`*^9, 3.492926841390552*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Choose", " ", "FixPoints", " ", "of", " ", "tiles", " ", "close", " ", 
    "to", " ", "their", " ", "centroids"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"P0inv", "=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{"Function", "[", 
        RowBox[{"z", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"Inverse", "[", "Q", "]"}], ".", 
           RowBox[{"(", 
            RowBox[{"z", "+", "#"}], ")"}]}], "&"}]}], "]"}], ",", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Apply", "[", 
           RowBox[{"#", ",", 
            RowBox[{"{", 
             RowBox[{"Table", "[", 
              RowBox[{"0", ",", 
               RowBox[{"{", "sz", "}"}]}], "]"}], "}"}]}], "]"}], "&"}], ",", 
         "P0", ",", 
         RowBox[{"{", "3", "}"}]}], "]"}], ",", 
       RowBox[{"{", "3", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Phinv", "=", "P0inv"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"While", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Fold", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"#1", "&&", "#2"}], "&"}], ",", "True", ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"Phinv", "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "i"}], "]"}], "]"}], "]"}], ">", "10"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "[", "Phinv", "]"}]}], "}"}]}], "]"}]}], "]"}],
        "\[Equal]", "False"}], ",", 
      RowBox[{
       RowBox[{"Qh", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Flatten", "[", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"Flatten", "[", 
              RowBox[{"Outer", "[", 
               RowBox[{"Composition", ",", 
                RowBox[{"P0inv", "[", 
                 RowBox[{"[", 
                  RowBox[{"j", ",", "k"}], "]"}], "]"}], ",", 
                RowBox[{"Phinv", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", "1"}], "]"}], 
              "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "1", ",", "dg"}], "}"}]}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", "dg"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"k", ",", "1", ",", "dg"}], "}"}]}], "]"}]}], ";", "\n", 
       RowBox[{"Phinv", "=", "Qh"}]}]}], "]"}], ";"}], 
   RowBox[{"(*", 
    RowBox[{"Anti", "-", 
     RowBox[{
     "product", " ", "of", " ", "the", " ", "matrix", " ", "is", " ", 
      "used"}]}], "*)"}], "\n", 
   RowBox[{
    RowBox[{"xy", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"x", "[", "j", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "1", ",", "sz"}], "}"}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"FixPt0", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"xy", "/.", 
             RowBox[{"Solve", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"#", "[", "xy", "]"}], "\[Equal]", "xy"}], ",", 
               "xy"}], "]"}]}], "&"}], ",", 
           RowBox[{"Phinv", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "i"}], "]"}], "]"}]}], "]"}], ",", "1"}], 
        "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "dg"}], "}"}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"CentFix", "=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{"Function", "[", 
        RowBox[{"z", ",", 
         RowBox[{
          RowBox[{"Fold", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"#1", "+", "#2"}], "&"}], ",", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", "sz", "}"}]}], "]"}], ",", "z"}], "]"}], "/", 
          RowBox[{"Length", "[", "z", "]"}]}]}], "]"}], ",", "FixPt0"}], 
      "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"FixPt", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", "1"}], ",", 
      RowBox[{"i", "\[LessEqual]", 
       RowBox[{"Length", "[", "FixPt0", "]"}]}], ",", 
      RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TransFix", "=", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Norm", "[", 
            RowBox[{
             RowBox[{"N", "[", "#", "]"}], ",", "2"}], "]"}], "&"}], ",", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"#", "-", 
              RowBox[{"CentFix", "[", 
               RowBox[{"[", "i", "]"}], "]"}]}], "&"}], ",", 
            RowBox[{"FixPt0", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"FixPt", "=", 
        RowBox[{"Append", "[", 
         RowBox[{"FixPt", ",", 
          RowBox[{"Extract", "[", 
           RowBox[{
            RowBox[{"FixPt0", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"First", "[", 
              RowBox[{"Position", "[", 
               RowBox[{"TransFix", ",", 
                RowBox[{"Min", "[", "TransFix", "]"}]}], "]"}], "]"}], 
             "}"}]}], "]"}]}], "\[IndentingNewLine]", "]"}]}]}]}], "]"}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{"FixPt", "=", 
     RowBox[{"Flatten", "[", 
      RowBox[{"FixPt", ",", "1"}], "]"}]}], ";"}], "\n", "\n", 
   RowBox[{"(*", " ", 
    RowBox[{"Translate", " ", 
     RowBox[{"digits", ":", 
      RowBox[{
      "so", " ", "that", " ", "all", " ", "tiles", " ", "contain", " ", "the",
        " ", "origin", " ", "as", " ", "a", " ", "fix", " ", "point"}]}]}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"DigMat", "=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Apply", "[", 
         RowBox[{"#", ",", 
          RowBox[{"{", 
           RowBox[{"Table", "[", 
            RowBox[{"0", ",", 
             RowBox[{"{", "sz", "}"}]}], "]"}], "}"}]}], "]"}], "&"}], ",", 
       "P0", ",", 
       RowBox[{"{", "3", "}"}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"DigMat2", "=", 
     RowBox[{"IdentityMatrix", "[", 
      RowBox[{"Length", "[", "DigMat", "]"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", "1"}], ",", 
      RowBox[{"i", "\[LessEqual]", 
       RowBox[{"Length", "[", "DigMat", "]"}]}], ",", 
      RowBox[{"i", "++"}], ",", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"j", "=", "1"}], ",", 
        RowBox[{"j", "\[LessEqual]", 
         RowBox[{"Length", "[", "DigMat", "]"}]}], ",", 
        RowBox[{"j", "++"}], ",", 
        RowBox[{
         RowBox[{"DigMat2", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "j"}], "]"}], "]"}], "=", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{"Function", "[", 
            RowBox[{"z", ",", 
             RowBox[{"z", "-", 
              RowBox[{"Q", ".", 
               RowBox[{"FixPt", "[", 
                RowBox[{"[", "j", "]"}], "]"}]}], "+", 
              RowBox[{"FixPt", "[", 
               RowBox[{"[", "i", "]"}], "]"}]}]}], "]"}], ",", 
           RowBox[{"DigMat", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "j"}], "]"}], "]"}]}], "]"}]}]}], "]"}]}], 
     "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"P0", "=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{"Function", "[", 
        RowBox[{"z", ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Q", ".", "#"}], "+", "z"}], ")"}], "&"}]}], "]"}], ",", 
       "DigMat2", ",", 
       RowBox[{"{", "3", "}"}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"P0inv", "=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{"Function", "[", 
        RowBox[{"z", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"Inverse", "[", "Q", "]"}], ".", 
           RowBox[{"(", 
            RowBox[{"#", "+", "z"}], ")"}]}], "&"}]}], "]"}], ",", "DigMat2", 
       ",", 
       RowBox[{"{", "3", "}"}]}], "]"}]}], ";"}], "\n", "\n", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
      "Choose", " ", "an", " ", "initial", " ", "fix", " ", "point", " ", 
       "for", " ", "Delone", " ", 
       RowBox[{"set", ".", " ", "#"}], " ", "of", " ", "power", " ", "of", 
       " ", 
       RowBox[{"Q", "^", "kp"}], " ", "must", " ", "satisfy", " ", 
       RowBox[{"Norm", "[", 
        RowBox[{
         RowBox[{"Q", "^", 
          RowBox[{"{", 
           RowBox[{"-", "kp"}], "}"}]}], ",", "2"}], "]"}]}], " ", "<", " ", 
      RowBox[{
      "Ratio", " ", "\[IndentingNewLine]", "with", " ", "Ratio", " ", "1.", 
       " ", "The", " ", "choice", " ", "of", " ", "Ratio", " ", "is", " ", 
       RowBox[{"subtle", ".", " ", "To"}], " ", "have", " ", "a", " ", 
       "better", " ", "bound", " ", "defining", " ", "potential", " ", 
       "overlap"}]}], ",", " ", 
     RowBox[{"choose", " ", "smaller", " ", 
      RowBox[{"Ratio", ".", " ", "However"}], " ", "as", " ", "kp", " ", 
      "increases"}], ",", " ", 
     RowBox[{
     "the", " ", "later", " ", "computational", " ", "size", " ", "becomes", 
      " ", 
      RowBox[{"large", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"kp", "=", "1"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Better", " ", "to", " ", "take", " ", "Ratio"}], "=", 
     RowBox[{
      RowBox[{"1", "/", "2"}], " ", "when", " ", "dimension", " ", "is", " ", 
      "not", " ", "greater", " ", "than", " ", "2"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"sz", ">", "2"}], ",", 
      RowBox[{"Ratio", "=", "1"}], ",", 
      RowBox[{"Ratio", "=", 
       RowBox[{"1", "/", "2"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rho", "=", "\[Infinity]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MinPow", "=", "1"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"While", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"rho", "=", 
         RowBox[{"Norm", "[", 
          RowBox[{
           RowBox[{"MatrixPower", "[", 
            RowBox[{
             RowBox[{"Q", "//", "N"}], ",", 
             RowBox[{"-", "MinPow"}]}], "]"}], ",", "2"}], "]"}]}], ")"}], 
       "\[GreaterEqual]", "Ratio"}], ",", 
      RowBox[{"MinPow", "++"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Ph", "=", "P0"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"While", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Fold", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"#1", "&&", "#2"}], "&"}], ",", "True", ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Ph", "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "i"}], "]"}], "]"}], "==", 
             RowBox[{"{", "}"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"Length", "[", "Ph", "]"}]}], "}"}]}], "]"}]}], "]"}], 
        "\[Equal]", "True"}], " ", "||", "  ", 
       RowBox[{"kp", "<", "MinPow"}]}], ",", 
      RowBox[{
       RowBox[{"Qh", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Flatten", "[", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"Flatten", "[", 
              RowBox[{"Outer", "[", 
               RowBox[{"Composition", ",", 
                RowBox[{"Ph", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", 
                RowBox[{"P0", "[", 
                 RowBox[{"[", 
                  RowBox[{"j", ",", "k"}], "]"}], "]"}], ",", "1"}], "]"}], 
              "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "1", ",", "dg"}], "}"}]}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", "dg"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"k", ",", "1", ",", "dg"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Ph", "=", "Qh"}], ";", 
       RowBox[{"kp", "++"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
   "\n", 
   RowBox[{
    RowBox[{"P", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"Length", "[", "P0", "]"}], "}"}]}], "]"}]}], ";"}], "\n", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Choose", " ", "an", " ", "initial", " ", "point", " ", "in", " ", 
     "Lambda_col"}], "*)"}], "\n", 
   RowBox[{
    RowBox[{"col", "=", 
     RowBox[{"First", "[", 
      RowBox[{"First", "[", 
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"Map", "[", 
          RowBox[{"Length", ",", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"Ph", "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "i"}], "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", "dg"}], "}"}]}], "]"}]}], "]"}], 
         ",", 
         RowBox[{"Max", "[", 
          RowBox[{"Map", "[", 
           RowBox[{"Length", ",", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"Ph", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "i"}], "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", "dg"}], "}"}]}], "]"}]}], "]"}], 
          "]"}]}], "]"}], "]"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{
     "\"\<Color \>\"", ",", " ", "col", ",", " ", 
      "\"\< Delone set is used.\>\""}], "]"}], ";"}], " ", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"P", "[", 
      RowBox[{"[", "col", "]"}], "]"}], "=", 
     RowBox[{"xy", "/.", 
      RowBox[{"Solve", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"First", "[", 
          RowBox[{"Ph", "[", 
           RowBox[{"[", 
            RowBox[{"col", ",", "col"}], "]"}], "]"}], "]"}], "[", "xy", 
         "]"}], "\[Equal]", "xy"}], "]"}]}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.474088908617284*^9, 3.4740889305620127`*^9}, {
   3.474089658355164*^9, 3.4740897197950706`*^9}, {3.474089845275303*^9, 
   3.4740898780417557`*^9}, {3.4741635286976223`*^9, 3.474163759156497*^9}, {
   3.474272142089034*^9, 3.474272159403861*^9}, {3.475042918182651*^9, 
   3.475042921413987*^9}, {3.475046464614616*^9, 3.475046467104745*^9}, {
   3.475254883574643*^9, 3.475254904467121*^9}, {3.475255015694975*^9, 
   3.4752550571536293`*^9}, {3.4753170799134703`*^9, 3.475317199265299*^9}, {
   3.4753172334012823`*^9, 3.475317358524674*^9}, {3.475317401531005*^9, 
   3.475317651618528*^9}, {3.475317736426931*^9, 3.475317738351663*^9}, {
   3.4753177853266783`*^9, 3.4753178479793243`*^9}, {3.4753179371284733`*^9, 
   3.475317943255937*^9}, {3.475318111011812*^9, 3.475318476083487*^9}, {
   3.475318506956699*^9, 3.475318533462604*^9}, {3.4753185995267973`*^9, 
   3.475318786548195*^9}, 3.475668020099654*^9, {3.4756689873373957`*^9, 
   3.475668993501214*^9}, {3.4756691022395363`*^9, 3.4756691484228277`*^9}, {
   3.47567007182872*^9, 3.475670154643458*^9}, {3.475671854553638*^9, 
   3.475671898233354*^9}, {3.475680704258103*^9, 3.4756807067905483`*^9}, {
   3.475681298477806*^9, 3.47568130038658*^9}, {3.475681333790805*^9, 
   3.475681348914854*^9}, {3.475682041496141*^9, 3.47568204440171*^9}, {
   3.475682395379059*^9, 3.475682448489635*^9}, {3.475682838001359*^9, 
   3.47568284541905*^9}, {3.475682895291806*^9, 3.4756829014250298`*^9}, {
   3.4756835129184504`*^9, 3.4756835190676327`*^9}, {3.475683661594532*^9, 
   3.475683665108842*^9}, {3.475683861590361*^9, 3.47568389001283*^9}, {
   3.4756840322171373`*^9, 3.4756840372960463`*^9}, {3.4756854675078697`*^9, 
   3.475685470797612*^9}, {3.475685781799308*^9, 3.475685787204969*^9}, {
   3.475685903535047*^9, 3.4756859087805767`*^9}, 3.476790506505582*^9, {
   3.476790593426433*^9, 3.4767906258556633`*^9}, {3.4767908556090517`*^9, 
   3.476790915174155*^9}, {3.476790968024768*^9, 3.476790986742021*^9}, {
   3.476791070774568*^9, 3.47679110569419*^9}, {3.476791206376417*^9, 
   3.476791270309*^9}, {3.476791308460001*^9, 3.476791352689073*^9}, {
   3.47679256733667*^9, 3.476792612411787*^9}, 3.47679264450343*^9, {
   3.4767938429343987`*^9, 3.476793843543591*^9}, {3.476793989174246*^9, 
   3.476793990315522*^9}, {3.47679572725651*^9, 3.476795730109583*^9}, {
   3.476795805506671*^9, 3.47679582197945*^9}, {3.476795992398129*^9, 
   3.4767960092534523`*^9}, {3.4767960620529413`*^9, 3.476796071680861*^9}, {
   3.476796227184114*^9, 3.47679623775878*^9}, {3.476796479017304*^9, 
   3.476796485244445*^9}, {3.476796546126347*^9, 3.4767965759482183`*^9}, {
   3.476796687615744*^9, 3.476796869916047*^9}, 3.476796953448241*^9, {
   3.4767989435880404`*^9, 3.47679898440902*^9}, {3.476799448550571*^9, 
   3.476799454457489*^9}, 3.4768081587938013`*^9, {3.476808191935524*^9, 
   3.4768081958271313`*^9}, {3.476808312215228*^9, 3.476808352273378*^9}, {
   3.4768086111214457`*^9, 3.476808641658543*^9}, {3.476809926004874*^9, 
   3.476809934708578*^9}, {3.476810146750709*^9, 3.476810147188293*^9}, {
   3.476811753549982*^9, 3.476811763443109*^9}, {3.476856047000346*^9, 
   3.476856054434188*^9}, {3.4768566456653767`*^9, 3.476856732332653*^9}, {
   3.476857157491609*^9, 3.476857207455893*^9}, {3.476857252478787*^9, 
   3.4768575886061*^9}, {3.477092159434359*^9, 3.477092171003859*^9}, {
   3.4770922349286823`*^9, 3.477092238086776*^9}, {3.477092325338983*^9, 
   3.4770923283780212`*^9}, {3.477092649330123*^9, 3.477092650017304*^9}, {
   3.4770926894843082`*^9, 3.4770927059718*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Additional", " ", 
    RowBox[{"information", ":", 
     RowBox[{"Draw", " ", "the", " ", "figure", " ", "of", " ", 
      RowBox[{"tiles", ":", 
       RowBox[{"This", " ", "is", " ", "not", " ", 
        RowBox[{"necessary", "."}]}]}]}]}]}], " ", "*)"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "#", " ", "of", " ", "Points", " ", "for", " ", "a", " ", "tile"}], " ", 
    "\[Tilde]", " ", "1000"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Rp2", "=", 
     RowBox[{"Floor", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"PF", ",", "1000"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Seeds", " ", "for", " ", 
     RowBox[{"attractors", ":", 
      RowBox[{"Fixed", " ", "points", " ", "of", " ", "diagonals"}]}]}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Ph0", "=", 
     RowBox[{
      RowBox[{"Partition", "[", 
       RowBox[{"FixPt", ",", "1"}], "]"}], "*", "0"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{"Ph0", "=", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{"Function", "[", 
          RowBox[{"z", ",", 
           RowBox[{"Apply", "[", 
            RowBox[{
             RowBox[{"z", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"z", "[", 
                 RowBox[{"[", "j", "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"j", ",", "2", ",", 
                  RowBox[{"sz", "+", "1"}]}], "}"}]}], "]"}], "}"}]}], 
            "]"}]}], "]"}], ",", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{"#", ",", 
              RowBox[{"sz", "+", "1"}]}], "]"}], "&"}], ",", 
           RowBox[{"Map", "[", 
            RowBox[{"Flatten", ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"Partition", "[", 
                  RowBox[{
                   RowBox[{"Flatten", "[", 
                    RowBox[{
                    RowBox[{"Outer", "[", 
                    RowBox[{"List", ",", 
                    RowBox[{"P0inv", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", 
                    RowBox[{"Ph0", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", "1"}], "]"}], ",", 
                    "2"}], "]"}], ",", "2"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "1", ",", "dg"}], "}"}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"j", ",", "1", ",", "dg"}], "}"}]}], "]"}]}], "]"}], 
           ",", "1"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
      RowBox[{"{", "Rp2", "}"}]}], "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Abs", "[", 
        RowBox[{
         RowBox[{"Im", "[", 
          RowBox[{"Q", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "//", "N"}], "]"}], 
       ">", 
       RowBox[{"100", "$MachineEpsilon"}]}], ",", 
      RowBox[{"Ph00", "=", 
       RowBox[{
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"z", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Re", "[", 
               RowBox[{"z", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
              RowBox[{"Im", "[", 
               RowBox[{"z", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], ",", 
          "Ph0", ",", 
          RowBox[{"{", "2", "}"}]}], "]"}], "//", "N"}]}], ",", 
      RowBox[{"Ph00", "=", "Ph0"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Ph00", "=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"PadRight", "[", 
         RowBox[{"#", ",", "2"}], "]"}], "&"}], ",", "Ph00", ",", 
       RowBox[{"{", "2", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Gen", "=", 
     RowBox[{"x", "+", "1"}]}], ";"}], 
   RowBox[{"(*", " ", 
    RowBox[{
    "Color", " ", "Generator", " ", "in", " ", "multiplicative", " ", "group",
      " ", "of", " ", "GF", 
     RowBox[{"(", 
      RowBox[{"3", "^", "3"}], ")"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"DualTiles", "=", 
     RowBox[{"Map", "[", 
      RowBox[{"Graphics", ",", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{"Function", "[", 
          RowBox[{"z", ",", 
           RowBox[{"Prepend", "[", 
            RowBox[{"z", ",", 
             RowBox[{"PointSize", "[", "0.005", "]"}]}], "]"}]}], "]"}], ",", 
         RowBox[{"MapThread", "[", 
          RowBox[{"List", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{"Function", "[", 
                RowBox[{"z", ",", 
                 RowBox[{"Apply", "[", 
                  RowBox[{"RGBColor", ",", "z"}], "]"}]}], "]"}], ",", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"0.4", "+", 
                  RowBox[{"0.4", 
                   RowBox[{"PadRight", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"CoefficientList", "[", 
                    RowBox[{
                    RowBox[{"PolynomialMod", "[", 
                    RowBox[{
                    RowBox[{"PolynomialRemainder", "[", 
                    RowBox[{
                    RowBox[{"Gen", "^", "i"}], ",", 
                    RowBox[{
                    RowBox[{"x", "^", "3"}], "-", "x", "-", "1"}], ",", "x"}],
                     "]"}], ",", "3"}], "]"}], ",", "x"}], "]"}], "/", "2"}], 
                    ",", "3"}], "]"}]}]}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "0", ",", 
                   RowBox[{"dg", "-", "1"}]}], "}"}]}], "]"}]}], "]"}], ",", 
             RowBox[{"Map", "[", 
              RowBox[{"Point", ",", "Ph00", ",", 
               RowBox[{"{", "2", "}"}]}], "]"}]}], "}"}]}], "]"}]}], "]"}]}], 
      "]"}]}], ";"}], "\n", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"DualTiles", "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"Axes", "\[Rule]", "True"}], ",", 
     RowBox[{"Axes", "\[Rule]", "True"}]}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"GraphicsArray", "[", "DualTiles", "]"}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "Automatic"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.474088908617284*^9, 3.4740889305620127`*^9}, {
   3.474089658355164*^9, 3.4740897197950706`*^9}, {3.474089845275303*^9, 
   3.4740898780417557`*^9}, {3.4741635286976223`*^9, 3.474163759156497*^9}, {
   3.474272142089034*^9, 3.474272159403861*^9}, {3.475042918182651*^9, 
   3.475042921413987*^9}, {3.475046464614616*^9, 3.475046467104745*^9}, {
   3.475254883574643*^9, 3.475254904467121*^9}, {3.475255015694975*^9, 
   3.4752550571536293`*^9}, {3.4753170799134703`*^9, 3.475317199265299*^9}, {
   3.4753172334012823`*^9, 3.475317358524674*^9}, {3.475317401531005*^9, 
   3.475317651618528*^9}, {3.475317736426931*^9, 3.475317738351663*^9}, {
   3.4753177853266783`*^9, 3.4753178479793243`*^9}, {3.4753179371284733`*^9, 
   3.475317943255937*^9}, {3.475318111011812*^9, 3.475318476083487*^9}, {
   3.475318506956699*^9, 3.475318533462604*^9}, {3.4753185995267973`*^9, 
   3.475318786548195*^9}, 3.475668020099654*^9, {3.4756689873373957`*^9, 
   3.475668993501214*^9}, {3.4756691022395363`*^9, 3.4756691484228277`*^9}, {
   3.47567007182872*^9, 3.475670154643458*^9}, {3.475671854553638*^9, 
   3.475671898233354*^9}, {3.475680704258103*^9, 3.4756807067905483`*^9}, {
   3.475681298477806*^9, 3.47568130038658*^9}, {3.475681333790805*^9, 
   3.475681348914854*^9}, {3.475682041496141*^9, 3.47568204440171*^9}, {
   3.475682395379059*^9, 3.475682448489635*^9}, {3.475682838001359*^9, 
   3.47568284541905*^9}, {3.475682895291806*^9, 3.4756829014250298`*^9}, {
   3.4756835129184504`*^9, 3.4756835190676327`*^9}, {3.475683661594532*^9, 
   3.475683665108842*^9}, {3.475683861590361*^9, 3.47568389001283*^9}, {
   3.4756840322171373`*^9, 3.4756840372960463`*^9}, {3.4756854675078697`*^9, 
   3.475685470797612*^9}, {3.475685781799308*^9, 3.475685787204969*^9}, {
   3.475685903535047*^9, 3.4756859087805767`*^9}, 3.476790506505582*^9, {
   3.476790593426433*^9, 3.4767906258556633`*^9}, {3.4767908556090517`*^9, 
   3.476790915174155*^9}, {3.476790968024768*^9, 3.476790986742021*^9}, {
   3.476791070774568*^9, 3.47679110569419*^9}, {3.476791206376417*^9, 
   3.476791270309*^9}, {3.476791308460001*^9, 3.476791352689073*^9}, {
   3.47679256733667*^9, 3.476792612411787*^9}, 3.47679264450343*^9, {
   3.4767938429343987`*^9, 3.476793843543591*^9}, {3.476793989174246*^9, 
   3.476793990315522*^9}, {3.47679572725651*^9, 3.476795730109583*^9}, {
   3.476795805506671*^9, 3.47679582197945*^9}, {3.476795992398129*^9, 
   3.4767960092534523`*^9}, {3.4767960620529413`*^9, 3.476796071680861*^9}, {
   3.476796227184114*^9, 3.47679623775878*^9}, {3.476796479017304*^9, 
   3.476796485244445*^9}, {3.476796546126347*^9, 3.4767965759482183`*^9}, {
   3.476796687615744*^9, 3.476796869916047*^9}, 3.476796953448241*^9, {
   3.4767989435880404`*^9, 3.47679898440902*^9}, {3.476799448550571*^9, 
   3.476799454457489*^9}, 3.4768081587938013`*^9, {3.476808191935524*^9, 
   3.4768081958271313`*^9}, {3.476808312215228*^9, 3.476808365249102*^9}, 
   3.477092814754681*^9, {3.4848639809930267`*^9, 3.4848639832867107`*^9}, {
   3.48486416983368*^9, 3.484864170207666*^9}, {3.484864329161573*^9, 
   3.4848643294836493`*^9}, {3.48486581835054*^9, 3.484865818565322*^9}, {
   3.4848659064704647`*^9, 3.484865907196664*^9}, {3.484866232533874*^9, 
   3.484866233260103*^9}, {3.484866351686973*^9, 3.484866353891429*^9}, {
   3.484866416766382*^9, 3.4848664171403008`*^9}, {3.484867255784628*^9, 
   3.484867256103204*^9}, {3.4848674003757343`*^9, 3.484867400926428*^9}, {
   3.4848675504151*^9, 3.48486755122115*^9}, {3.484867611710938*^9, 
   3.4848676395492268`*^9}, {3.484867672547998*^9, 3.4848676728612137`*^9}, {
   3.484878594557592*^9, 3.4848785947715263`*^9}, {3.4848998702463503`*^9, 
   3.484899871144541*^9}, {3.4849002451138372`*^9, 3.484900272466354*^9}, {
   3.484900894218161*^9, 3.484900898752143*^9}, {3.484901318630617*^9, 
   3.484901319372403*^9}, {3.484901392326108*^9, 3.484901392844474*^9}, {
   3.484901545870566*^9, 3.484901553707045*^9}, {3.484902063393672*^9, 
   3.484902064040564*^9}, {3.484902270409486*^9, 3.4849022708524437`*^9}, {
   3.4849023594653597`*^9, 3.484902389294421*^9}, {3.4849038061898203`*^9, 
   3.4849038071710653`*^9}, {3.4850799362745237`*^9, 3.485079936545188*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Draw", " ", "Delone", " ", "multi"}], "-", 
    RowBox[{"color", " ", "set"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"#", " ", "of", " ", "Points"}], " ", "\[Tilde]", " ", "10"}], 
   " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"Rp3", "=", 
     RowBox[{"Ceiling", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"PF", ",", "15"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"w0", "=", "P"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Fixed", " ", 
     RowBox[{"point", ":", 
      RowBox[{
       RowBox[{"Delone", " ", "multi"}], "-", 
       RowBox[{"color", " ", "set"}]}]}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{"w0", "=", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{"Function", "[", 
          RowBox[{"z", ",", 
           RowBox[{"Apply", "[", 
            RowBox[{
             RowBox[{"z", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"z", "[", 
                 RowBox[{"[", "j", "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"j", ",", "2", ",", 
                  RowBox[{"sz", "+", "1"}]}], "}"}]}], "]"}], "}"}]}], 
            "]"}]}], "]"}], ",", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{"#", ",", 
              RowBox[{"sz", "+", "1"}]}], "]"}], "&"}], ",", 
           RowBox[{"Map", "[", 
            RowBox[{"Flatten", ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"Partition", "[", 
                  RowBox[{
                   RowBox[{"Flatten", "[", 
                    RowBox[{
                    RowBox[{"Outer", "[", 
                    RowBox[{"List", ",", 
                    RowBox[{"P0", "[", 
                    RowBox[{"[", 
                    RowBox[{"j", ",", "i"}], "]"}], "]"}], ",", 
                    RowBox[{"w0", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", "1"}], "]"}], ",", 
                    "2"}], "]"}], ",", "2"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "1", ",", "dg"}], "}"}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"j", ",", "1", ",", "dg"}], "}"}]}], "]"}]}], "]"}], 
           ",", "1"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
      RowBox[{"{", "Rp3", "}"}]}], "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Abs", "[", 
        RowBox[{
         RowBox[{"Im", "[", 
          RowBox[{"Q", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "//", "N"}], "]"}], 
       ">", 
       RowBox[{"100", "$MachineEpsilon"}]}], ",", 
      RowBox[{"w00", "=", 
       RowBox[{
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"z", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Re", "[", 
               RowBox[{"z", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
              RowBox[{"Im", "[", 
               RowBox[{"z", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], ",", 
          "w0", ",", 
          RowBox[{"{", "2", "}"}]}], "]"}], "//", "N"}]}], ",", 
      RowBox[{"w00", "=", "w0"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"w00", "=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"PadRight", "[", 
         RowBox[{"#", ",", "2"}], "]"}], "&"}], ",", "w00", ",", 
       RowBox[{"{", "2", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"Delone", "=", 
      RowBox[{"Map", "[", 
       RowBox[{"Graphics", ",", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"z", ",", 
            RowBox[{"Prepend", "[", 
             RowBox[{"z", ",", 
              RowBox[{"PointSize", "[", "0.03", "]"}]}], "]"}]}], "]"}], ",", 
          RowBox[{"MapThread", "[", 
           RowBox[{"List", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Map", "[", 
               RowBox[{
                RowBox[{"Function", "[", 
                 RowBox[{"z", ",", 
                  RowBox[{"Apply", "[", 
                   RowBox[{"RGBColor", ",", "z"}], "]"}]}], "]"}], ",", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"0.4", "+", 
                   RowBox[{"0.4", 
                    RowBox[{"PadRight", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"CoefficientList", "[", 
                    RowBox[{
                    RowBox[{"PolynomialMod", "[", 
                    RowBox[{
                    RowBox[{"PolynomialRemainder", "[", 
                    RowBox[{
                    RowBox[{"Gen", "^", "i"}], ",", 
                    RowBox[{
                    RowBox[{"x", "^", "3"}], "-", "x", "-", "1"}], ",", "x"}],
                     "]"}], ",", "3"}], "]"}], ",", "x"}], "]"}], "/", "2"}], 
                    ",", "3"}], "]"}]}]}], ",", 
                  RowBox[{"{", 
                   RowBox[{"i", ",", "0", ",", 
                    RowBox[{"dg", "-", "1"}]}], "}"}]}], "]"}]}], "]"}], ",", 
              RowBox[{"Map", "[", 
               RowBox[{"Point", ",", "w00", ",", 
                RowBox[{"{", "2", "}"}]}], "]"}]}], "}"}]}], "]"}]}], "]"}]}],
        "]"}]}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "Automatic"}]}], "]"}], "\n", 
   RowBox[{"Show", "[", 
    RowBox[{"GraphicsArray", "[", "Delone", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.474088908617284*^9, 3.4740889305620127`*^9}, {
   3.474089658355164*^9, 3.4740897197950706`*^9}, {3.474089845275303*^9, 
   3.4740898780417557`*^9}, {3.4741635286976223`*^9, 3.474163759156497*^9}, {
   3.474272142089034*^9, 3.474272159403861*^9}, {3.475042918182651*^9, 
   3.475042921413987*^9}, {3.475046464614616*^9, 3.475046467104745*^9}, {
   3.475254883574643*^9, 3.475254904467121*^9}, {3.475255015694975*^9, 
   3.4752550571536293`*^9}, {3.4753170799134703`*^9, 3.475317199265299*^9}, {
   3.4753172334012823`*^9, 3.475317358524674*^9}, {3.475317401531005*^9, 
   3.475317651618528*^9}, {3.475317736426931*^9, 3.475317738351663*^9}, {
   3.4753177853266783`*^9, 3.4753178479793243`*^9}, {3.4753179371284733`*^9, 
   3.475317943255937*^9}, {3.475318111011812*^9, 3.475318476083487*^9}, {
   3.475318506956699*^9, 3.475318533462604*^9}, {3.4753185995267973`*^9, 
   3.475318786548195*^9}, 3.475668020099654*^9, {3.4756689873373957`*^9, 
   3.475668993501214*^9}, {3.4756691022395363`*^9, 3.4756691484228277`*^9}, {
   3.47567007182872*^9, 3.475670154643458*^9}, {3.475671854553638*^9, 
   3.475671898233354*^9}, {3.475680704258103*^9, 3.4756807067905483`*^9}, {
   3.475681298477806*^9, 3.47568130038658*^9}, {3.475681333790805*^9, 
   3.475681348914854*^9}, {3.475682041496141*^9, 3.47568204440171*^9}, {
   3.475682395379059*^9, 3.475682448489635*^9}, {3.475682838001359*^9, 
   3.47568284541905*^9}, {3.475682895291806*^9, 3.4756829014250298`*^9}, {
   3.4756835129184504`*^9, 3.4756835190676327`*^9}, {3.475683661594532*^9, 
   3.475683665108842*^9}, {3.475683861590361*^9, 3.47568389001283*^9}, {
   3.4756840322171373`*^9, 3.4756840372960463`*^9}, {3.4756854675078697`*^9, 
   3.475685470797612*^9}, {3.475685781799308*^9, 3.475685787204969*^9}, {
   3.475685903535047*^9, 3.4756859087805767`*^9}, 3.476790506505582*^9, {
   3.476790593426433*^9, 3.4767906258556633`*^9}, {3.4767908556090517`*^9, 
   3.476790915174155*^9}, {3.476790968024768*^9, 3.476790986742021*^9}, {
   3.476791070774568*^9, 3.47679110569419*^9}, {3.476791206376417*^9, 
   3.476791270309*^9}, {3.476791308460001*^9, 3.476791352689073*^9}, {
   3.47679256733667*^9, 3.476792612411787*^9}, 3.47679264450343*^9, {
   3.4767938429343987`*^9, 3.476793843543591*^9}, {3.476793989174246*^9, 
   3.476793990315522*^9}, {3.47679572725651*^9, 3.476795730109583*^9}, {
   3.476795805506671*^9, 3.47679582197945*^9}, {3.476795992398129*^9, 
   3.4767960092534523`*^9}, {3.4767960620529413`*^9, 3.476796071680861*^9}, {
   3.476796227184114*^9, 3.47679623775878*^9}, {3.476796479017304*^9, 
   3.476796485244445*^9}, {3.476796546126347*^9, 3.4767965759482183`*^9}, {
   3.476796687615744*^9, 3.476796869916047*^9}, 3.476796953448241*^9, {
   3.4767989435880404`*^9, 3.47679898440902*^9}, {3.476799448550571*^9, 
   3.476799454457489*^9}, 3.4768081587938013`*^9, {3.476808191935524*^9, 
   3.4768081958271313`*^9}, {3.476808312215228*^9, 3.4768083828317547`*^9}, {
   3.477092846623189*^9, 3.4770928795630217`*^9}, {3.484865603494323*^9, 
   3.484865604084339*^9}, {3.4848657744195967`*^9, 3.484865775779611*^9}, {
   3.484866056253541*^9, 3.484866076621279*^9}, {3.484866168918141*^9, 
   3.484866223505712*^9}, {3.484866287364953*^9, 3.48486628875559*^9}, {
   3.48486637553269*^9, 3.484866376258679*^9}, {3.484867347463677*^9, 
   3.484867348534052*^9}, {3.4848673876716223`*^9, 3.484867392486042*^9}, {
   3.48487861113842*^9, 3.484878613307365*^9}, {3.484878958667242*^9, 
   3.484878967042605*^9}, {3.4848998835657063`*^9, 3.4848998854284782`*^9}, {
   3.484899920719658*^9, 3.4848999358029203`*^9}, {3.484900110373227*^9, 
   3.484900115225851*^9}, {3.484900186316162*^9, 3.4849001871143217`*^9}, {
   3.484902212977316*^9, 3.484902217566331*^9}, {3.4850799422595987`*^9, 
   3.485079943455453*^9}, {3.485303229910816*^9, 3.4853032319259367`*^9}, {
   3.485303345527083*^9, 3.485303371805793*^9}, {3.485308584834269*^9, 
   3.48530858589421*^9}, {3.485660208882062*^9, 3.4856602309471207`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Additonal", " ", 
    RowBox[{"information", ":", 
     RowBox[{
      RowBox[{
      "Number", " ", "of", " ", "points", " ", "in", " ", "Delone", " ", 
       "multi"}], "-", 
      RowBox[{"color", " ", "sets"}]}]}]}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{"Length", "[", 
    RowBox[{"Flatten", "[", 
     RowBox[{"w0", ",", "1"}], "]"}], "]"}], "\n", 
   RowBox[{"Length", "[", 
    RowBox[{"Union", "[", 
     RowBox[{"Flatten", "[", 
      RowBox[{"w0", ",", "1"}], "]"}], "]"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"Map", "[", 
    RowBox[{"Length", ",", "w0"}], "]"}], "\n", 
   RowBox[{"Map", "[", 
    RowBox[{"Length", ",", 
     RowBox[{"Map", "[", 
      RowBox[{"Union", ",", "w0"}], "]"}]}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Tiling", " ", "and", " ", "point", " ", "sets"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Til", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", "1"}], ",", 
      RowBox[{"i", "\[LessEqual]", 
       RowBox[{"Length", "[", "w00", "]"}]}], ",", 
      RowBox[{"i", "++"}], ",", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"j", "=", "1"}], ",", 
        RowBox[{"j", "\[LessEqual]", 
         RowBox[{"Length", "[", 
          RowBox[{"w00", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ",", 
        RowBox[{"j", "++"}], ",", 
        RowBox[{"Til", "=", 
         RowBox[{"Append", "[", 
          RowBox[{"Til", ",", 
           RowBox[{"Graphics", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"PointSize", "[", "0.005", "]"}], ",", 
              RowBox[{"Apply", "[", 
               RowBox[{"RGBColor", ",", 
                RowBox[{"0.4", "+", 
                 RowBox[{"0.4", 
                  RowBox[{"PadRight", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"CoefficientList", "[", 
                    RowBox[{
                    RowBox[{"PolynomialMod", "[", 
                    RowBox[{
                    RowBox[{"PolynomialRemainder", "[", 
                    RowBox[{
                    RowBox[{"Gen", "^", "i"}], ",", 
                    RowBox[{
                    RowBox[{"x", "^", "3"}], "-", "x", "-", "1"}], ",", "x"}],
                     "]"}], ",", "3"}], "]"}], ",", "x"}], "]"}], "/", "2"}], 
                    ",", "3"}], "]"}]}]}]}], "]"}], ",", 
              RowBox[{"Map", "[", 
               RowBox[{"Point", ",", 
                RowBox[{"Map", "[", 
                 RowBox[{
                  RowBox[{"Function", "[", 
                   RowBox[{"z", ",", 
                    RowBox[{"z", "+", 
                    RowBox[{
                    RowBox[{"w00", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}]}], "]"}], ",", 
                  RowBox[{"Ph00", "[", 
                   RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ",", 
                RowBox[{"{", "1", "}"}]}], "]"}]}], "}"}], "]"}]}], "]"}]}]}],
        "]"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Til", ",", 
       RowBox[{"Map", "[", 
        RowBox[{"Graphics", ",", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{"Function", "[", 
            RowBox[{"z", ",", 
             RowBox[{"Prepend", "[", 
              RowBox[{"z", ",", 
               RowBox[{"PointSize", "[", "0.01", "]"}]}], "]"}]}], 
            "\[IndentingNewLine]", "]"}], ",", 
           RowBox[{"MapThread", "[", 
            RowBox[{"List", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Map", "[", 
                RowBox[{
                 RowBox[{"Function", "[", 
                  RowBox[{"z", ",", 
                   RowBox[{"Apply", "[", 
                    RowBox[{"RGBColor", ",", "z"}], "]"}]}], "]"}], ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0.7", ",", "0.7", ",", "0.7"}], "}"}], "-", 
                    RowBox[{"0.7", 
                    RowBox[{"PadRight", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"CoefficientList", "[", 
                    RowBox[{
                    RowBox[{"PolynomialMod", "[", 
                    RowBox[{
                    RowBox[{"PolynomialRemainder", "[", 
                    RowBox[{
                    RowBox[{"Gen", "^", "i"}], ",", 
                    RowBox[{
                    RowBox[{"x", "^", "3"}], "-", "x", "-", "1"}], ",", "x"}],
                     "]"}], ",", "3"}], "]"}], ",", "x"}], "]"}], "/", "2"}], 
                    ",", "3"}], "]"}]}]}], ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", "0", ",", 
                    RowBox[{"dg", "-", "1"}]}], "}"}]}], "]"}]}], "]"}], ",", 
               RowBox[{"Map", "[", 
                RowBox[{"Point", ",", "w00", ",", 
                 RowBox[{"{", "2", "}"}]}], "]"}]}], "}"}]}], "]"}]}], 
          "]"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "Automatic"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.474088908617284*^9, 3.4740889305620127`*^9}, {
   3.474089658355164*^9, 3.4740897197950706`*^9}, {3.474089845275303*^9, 
   3.4740898780417557`*^9}, {3.4741635286976223`*^9, 3.474163759156497*^9}, {
   3.474272142089034*^9, 3.474272159403861*^9}, {3.475042918182651*^9, 
   3.475042921413987*^9}, {3.475046464614616*^9, 3.475046467104745*^9}, {
   3.475254883574643*^9, 3.475254904467121*^9}, {3.475255015694975*^9, 
   3.4752550571536293`*^9}, {3.4753170799134703`*^9, 3.475317199265299*^9}, {
   3.4753172334012823`*^9, 3.475317358524674*^9}, {3.475317401531005*^9, 
   3.475317651618528*^9}, {3.475317736426931*^9, 3.475317738351663*^9}, {
   3.4753177853266783`*^9, 3.4753178479793243`*^9}, {3.4753179371284733`*^9, 
   3.475317943255937*^9}, {3.475318111011812*^9, 3.475318476083487*^9}, {
   3.475318506956699*^9, 3.475318533462604*^9}, {3.4753185995267973`*^9, 
   3.475318786548195*^9}, 3.475668020099654*^9, {3.4756689873373957`*^9, 
   3.475668993501214*^9}, {3.4756691022395363`*^9, 3.4756691484228277`*^9}, {
   3.47567007182872*^9, 3.475670154643458*^9}, {3.475671854553638*^9, 
   3.475671898233354*^9}, {3.475680704258103*^9, 3.4756807067905483`*^9}, {
   3.475681298477806*^9, 3.47568130038658*^9}, {3.475681333790805*^9, 
   3.475681348914854*^9}, {3.475682041496141*^9, 3.47568204440171*^9}, {
   3.475682395379059*^9, 3.475682448489635*^9}, {3.475682838001359*^9, 
   3.47568284541905*^9}, {3.475682895291806*^9, 3.4756829014250298`*^9}, {
   3.4756835129184504`*^9, 3.4756835190676327`*^9}, {3.475683661594532*^9, 
   3.475683665108842*^9}, {3.475683861590361*^9, 3.47568389001283*^9}, {
   3.4756840322171373`*^9, 3.4756840372960463`*^9}, {3.4756854675078697`*^9, 
   3.475685470797612*^9}, {3.475685781799308*^9, 3.475685787204969*^9}, {
   3.475685903535047*^9, 3.4756859087805767`*^9}, 3.476790506505582*^9, {
   3.476790593426433*^9, 3.4767906258556633`*^9}, {3.4767908556090517`*^9, 
   3.476790915174155*^9}, {3.476790968024768*^9, 3.476790986742021*^9}, {
   3.476791070774568*^9, 3.47679110569419*^9}, {3.476791206376417*^9, 
   3.476791270309*^9}, {3.476791308460001*^9, 3.476791352689073*^9}, {
   3.47679256733667*^9, 3.476792612411787*^9}, 3.47679264450343*^9, {
   3.4767938429343987`*^9, 3.476793843543591*^9}, {3.476793989174246*^9, 
   3.476793990315522*^9}, {3.47679572725651*^9, 3.476795730109583*^9}, {
   3.476795805506671*^9, 3.47679582197945*^9}, {3.476795992398129*^9, 
   3.4767960092534523`*^9}, {3.4767960620529413`*^9, 3.476796071680861*^9}, {
   3.476796227184114*^9, 3.47679623775878*^9}, {3.476796479017304*^9, 
   3.476796485244445*^9}, {3.476796546126347*^9, 3.4767965759482183`*^9}, {
   3.476796687615744*^9, 3.476796869916047*^9}, 3.476796953448241*^9, {
   3.4767989435880404`*^9, 3.47679898440902*^9}, {3.476799448550571*^9, 
   3.476799454457489*^9}, 3.4768081587938013`*^9, {3.476808191935524*^9, 
   3.4768081958271313`*^9}, {3.476808312215228*^9, 3.476808394438513*^9}, {
   3.4770929200839376`*^9, 3.4770929542800503`*^9}, {3.484878859963622*^9, 
   3.484878864116205*^9}, {3.4848789867418623`*^9, 3.4848790038360147`*^9}, {
   3.484879059245905*^9, 3.484879065978503*^9}, 3.484899946654212*^9, {
   3.484900123435882*^9, 3.4849001580866947`*^9}, {3.484900949225788*^9, 
   3.48490095965298*^9}, {3.484901119262265*^9, 3.4849011203472357`*^9}, {
   3.4849014928382196`*^9, 3.484901495017852*^9}, {3.484901534117525*^9, 
   3.484901534489437*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"If", " ", "the", " ", "data", " ", "is", " ", "complex"}], ",", 
    " ", 
    RowBox[{"'", 
     RowBox[{"Lat", "'"}], " ", "transfers", " ", "it", " ", "to", " ", 
     "real", " ", 
     RowBox[{"vectors", ".", " ", "Note"}], " ", "that", " ", "when", " ", 
     "Q", " ", "is", " ", "a", " ", "diagonal", " ", "matrix", " ", "and", 
     " ", "some", " ", "entry", " ", "of", " ", "Q", " ", "is", " ", 
     "complex"}], ",", " ", 
    RowBox[{
    "a", " ", "2", " ", "by", " ", "2", " ", "block", " ", "on", " ", "the", 
     " ", "diagonal", " ", "of", " ", "Q", " ", "consists", " ", "of", " ", 
     "complex", " ", "conjugates", " ", "in", " ", "pairs"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Lat", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{"Im", "[", 
              RowBox[{"N", "[", 
               RowBox[{"Q", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "i"}], "]"}], "]"}], "]"}], "]"}], "]"}], 
            ">", 
            RowBox[{"100", "$MachineEpsilon"}]}], ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"OddQ", "[", "i", "]"}], ",", 
             RowBox[{"Re", "[", 
              RowBox[{"N", "[", 
               RowBox[{"z", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", 
             RowBox[{"Im", "[", 
              RowBox[{"N", "[", 
               RowBox[{"z", "[", 
                RowBox[{"[", 
                 RowBox[{"i", "-", "1"}], "]"}], "]"}], "]"}], "]"}]}], "]"}],
            ",", 
           RowBox[{"z", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "z", "]"}]}], "}"}]}], "]"}]}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", "\n", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Prepare", " ", "full", " ", "rank", " ", "return", " ", "vectors"}], " ",
     "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"w0", "=", "P"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"w", "=", 
     RowBox[{"First", "[", 
      RowBox[{"P", "[", 
       RowBox[{"[", "col", "]"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"L1", "=", 
     RowBox[{"{", 
      RowBox[{"{", "0", "}"}], "}"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"While", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"MatrixRank", "[", "L1", "]"}], "<", "sz"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"w0", "=", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"z", ",", 
            RowBox[{"Apply", "[", 
             RowBox[{
              RowBox[{"z", "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"z", "[", 
                  RowBox[{"[", "j", "]"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"j", ",", "2", ",", 
                   RowBox[{"sz", "+", "1"}]}], "}"}]}], "]"}], "}"}]}], 
             "]"}]}], "]"}], ",", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{"#", ",", 
               RowBox[{"sz", "+", "1"}]}], "]"}], "&"}], ",", 
            RowBox[{"Map", "[", 
             RowBox[{"Flatten", ",", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"Partition", "[", 
                   RowBox[{
                    RowBox[{"Flatten", "[", 
                    RowBox[{
                    RowBox[{"Outer", "[", 
                    RowBox[{"List", ",", 
                    RowBox[{"Ph", "[", 
                    RowBox[{"[", 
                    RowBox[{"j", ",", "i"}], "]"}], "]"}], ",", 
                    RowBox[{"w0", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", "1"}], "]"}], ",", 
                    "2"}], "]"}], ",", "2"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"i", ",", "1", ",", "dg"}], "}"}]}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"j", ",", "1", ",", "dg"}], "}"}]}], "]"}]}], "]"}], 
            ",", "1"}], "]"}], ",", 
          RowBox[{"{", "2", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"L1", "=", 
        RowBox[{"Sort", "[", 
         RowBox[{
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{"Function", "[", 
             RowBox[{"z", ",", 
              RowBox[{"z", "-", "w"}]}], "]"}], ",", 
            RowBox[{"w0", "[", 
             RowBox[{"[", "col", "]"}], "]"}], ",", "1"}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"Norm", "[", 
             RowBox[{
              RowBox[{"N", "[", "#1", "]"}], ",", "2"}], "]"}], "<", 
            RowBox[{"Norm", "[", 
             RowBox[{
              RowBox[{"N", "[", "#2", "]"}], ",", "2"}], "]"}]}], "&"}]}], 
         "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"j", "=", "0"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"rt1", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"i", "=", "1"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"While", "[", 
     RowBox[{
      RowBox[{"j", "<", "sz"}], ",", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"MatrixRank", "[", 
           RowBox[{"Take", "[", 
            RowBox[{"L1", ",", "i"}], "]"}], "]"}], ">", "j"}], ",", 
         RowBox[{
          RowBox[{"rt1", "=", 
           RowBox[{"Append", "[", 
            RowBox[{"rt1", ",", 
             RowBox[{"L1", "[", 
              RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], ";", 
          RowBox[{"j", "=", 
           RowBox[{"MatrixRank", "[", 
            RowBox[{"Take", "[", 
             RowBox[{"L1", ",", "i"}], "]"}], "]"}]}]}]}], "]"}], ";", 
       RowBox[{"i", "++"}]}]}], "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{
     "\"\<Return vectors of \>\"", ",", "w", ",", "\"\< is \>\"", ",", 
      "rt1"}], "]"}], ";"}], "\n", 
   RowBox[{"(*", " ", 
    RowBox[{"Return", " ", "vector", " ", "length"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"al", "=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Norm", "[", 
         RowBox[{
          RowBox[{"Lat", "[", "#", "]"}], ",", "2"}], "]"}], "&"}], ",", 
       RowBox[{"rt1", "//", "N"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Geometric", " ", "Substitution", " ", "Data"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Rl0", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"P0dig", "=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Apply", "[", 
         RowBox[{"#", ",", 
          RowBox[{"{", 
           RowBox[{"Table", "[", 
            RowBox[{"0", ",", 
             RowBox[{"{", "sz", "}"}]}], "]"}], "}"}]}], "]"}], "&"}], ",", 
       "P0", ",", 
       RowBox[{"{", "3", "}"}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"j", "=", "1"}], ",", 
      RowBox[{"j", "\[LessEqual]", "dg"}], ",", 
      RowBox[{"j", "++"}], ",", 
      RowBox[{
       RowBox[{"Tes", "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", "dg"}], ",", 
         RowBox[{"i", "++"}], ",", 
         RowBox[{"Tes", "=", 
          RowBox[{"Append", "[", 
           RowBox[{"Tes", ",", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{"Function", "[", 
               RowBox[{"z", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "-", "1"}], ",", "z"}], "}"}]}], "]"}], ",", 
              RowBox[{"P0dig", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "j"}], "]"}], "]"}]}], "]"}]}], "]"}]}]}], 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Rl0", "=", 
        RowBox[{"Append", "[", 
         RowBox[{"Rl0", ",", 
          RowBox[{"Flatten", "[", 
           RowBox[{"Tes", ",", "1"}], "]"}]}], "]"}]}], ";"}]}], "]"}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Geometric", " ", "substitution"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Gsbst", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"#", "+", 
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{"Q", ".", 
              RowBox[{"Last", "[", "z", "]"}]}]}], "}"}]}], "&"}], ",", 
         RowBox[{"Rl0", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"First", "[", "z", "]"}], "+", "1"}], "]"}], "]"}]}], 
        "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Gs", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"Map", "[", 
          RowBox[{"Gsbst", ",", "z"}], "]"}], ",", "1"}], "]"}]}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Initial", " ", "Ov", " ", "should", " ", "not", " ", "be", " ", 
     "empty"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rp", "=", "0"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"St1", "=", 
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{"Function", "[", 
          RowBox[{"z", ",", 
           RowBox[{"Map", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"z", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", "#"}], "}"}], "&"}], 
             ",", 
             RowBox[{"Last", "[", "z", "]"}]}], "]"}]}], "]"}], ",", 
         RowBox[{"MapThread", "[", 
          RowBox[{"List", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"Range", "[", 
               RowBox[{"Length", "[", "P", "]"}], "]"}], "-", "1"}], ",", 
             "P"}], "}"}]}], "]"}]}], "]"}], ",", "1"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Compute", " ", "the", " ", "period", " ", "of", " ", "the", " ", 
     "starting", " ", "point", " ", "by", " ", 
     RowBox[{"substitution", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Period", "=", "1"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"While", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Complement", "[", 
        RowBox[{"St1", ",", 
         RowBox[{"Nest", "[", 
          RowBox[{"Gs", ",", "St1", ",", "Period"}], "]"}]}], "]"}], "=!=", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"Period", "++"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Compute", " ", "block", " ", 
     RowBox[{"digits", " ", "\\", "sum"}], " ", 
     RowBox[{"Q", "^", 
      RowBox[{"{", 
       RowBox[{"-", "n"}], "}"}]}], " ", "D_", 
     RowBox[{"{", "ij", "}"}], " ", "of", " ", "length", " ", "Period", " ", 
     RowBox[{"Ceiling", "[", 
      RowBox[{"MinPow", "/", "Period"}], "]"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Ph0", "=", 
     RowBox[{
      RowBox[{"Partition", "[", 
       RowBox[{"FixPt", ",", "1"}], "]"}], "*", "0"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{"Ph0", "=", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{"Function", "[", 
          RowBox[{"z", ",", 
           RowBox[{"Apply", "[", 
            RowBox[{
             RowBox[{"z", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"z", "[", 
                 RowBox[{"[", "j", "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"j", ",", "2", ",", 
                  RowBox[{"sz", "+", "1"}]}], "}"}]}], "]"}], "}"}]}], 
            "]"}]}], "]"}], ",", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{"#", ",", 
              RowBox[{"sz", "+", "1"}]}], "]"}], "&"}], ",", 
           RowBox[{"Map", "[", 
            RowBox[{"Flatten", ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"Partition", "[", 
                  RowBox[{
                   RowBox[{"Flatten", "[", 
                    RowBox[{
                    RowBox[{"Outer", "[", 
                    RowBox[{"List", ",", 
                    RowBox[{"P0inv", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", 
                    RowBox[{"Ph0", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", "1"}], "]"}], ",", 
                    "2"}], "]"}], ",", "2"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "1", ",", "dg"}], "}"}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"j", ",", "1", ",", "dg"}], "}"}]}], "]"}]}], "]"}], 
           ",", "1"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"Period", " ", 
        RowBox[{"Ceiling", "[", 
         RowBox[{"MinPow", "/", "Period"}], "]"}]}], "}"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", "\n", " ", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
     "Compute", " ", "an", " ", "upper", " ", "bound", " ", "of", " ", 
      "difference", " ", "of", " ", "two", " ", "tiles", " ", "T_i"}], "-", 
     "T_j"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Dig", "=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"MatrixPower", "[", 
          RowBox[{"Q", ",", 
           RowBox[{"Period", " ", 
            RowBox[{"Ceiling", "[", 
             RowBox[{"MinPow", "/", "Period"}], "]"}]}]}], "]"}], ".", "#"}], 
        "&"}], ",", 
       RowBox[{"Flatten", "[", 
        RowBox[{"Ph0", ",", "1"}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Dig2", "=", 
     RowBox[{
      RowBox[{"Union", "[", 
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"Outer", "[", 
          RowBox[{"Subtract", ",", "Dig", ",", "Dig", ",", "1"}], "]"}], ",", 
         "1"}], "]"}], "]"}], "//", "N"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"rho", "=", 
     RowBox[{"Norm", "[", 
      RowBox[{
       RowBox[{"MatrixPower", "[", 
        RowBox[{
         RowBox[{"Q", "//", "N"}], ",", 
         RowBox[{
          RowBox[{"-", "Period"}], " ", 
          RowBox[{"Ceiling", "[", 
           RowBox[{"MinPow", "/", "Period"}], "]"}]}]}], "]"}], ",", "2"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"diam", "=", 
     RowBox[{
      RowBox[{"Max", "[", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Norm", "[", 
           RowBox[{"#", ",", "2"}], "]"}], "&"}], ",", 
         RowBox[{"Map", "[", 
          RowBox[{"Lat", ",", "Dig2"}], "]"}]}], "]"}], "]"}], 
      RowBox[{"rho", "/", 
       RowBox[{"(", 
        RowBox[{"1", "-", "rho"}], ")"}]}]}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{
     "\"\<Upper Bound of difference of two tiles = \>\"", ",", "diam"}], 
     "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Rdm", "=", 
     RowBox[{"diam", "+", 
      RowBox[{"rho", " ", 
       RowBox[{"Max", "[", "al", "]"}]}]}]}], ";"}], " ", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Constant", " ", "for", " ", "Potential", " ", "overlap", " ", 
     "computation"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Set", " ", "initial", " ", "overlaps"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"OvTwo", "=", 
     RowBox[{"{", "\[Infinity]", "}"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.474088908617284*^9, 3.4740889305620127`*^9}, {
   3.474089658355164*^9, 3.4740897197950706`*^9}, {3.474089845275303*^9, 
   3.4740898780417557`*^9}, {3.4741635286976223`*^9, 3.474163759156497*^9}, {
   3.474272142089034*^9, 3.474272159403861*^9}, {3.475042918182651*^9, 
   3.475042921413987*^9}, {3.475046464614616*^9, 3.475046467104745*^9}, {
   3.475254883574643*^9, 3.475254904467121*^9}, {3.475255015694975*^9, 
   3.4752550571536293`*^9}, {3.4753170799134703`*^9, 3.475317199265299*^9}, {
   3.4753172334012823`*^9, 3.475317358524674*^9}, {3.475317401531005*^9, 
   3.475317651618528*^9}, {3.475317736426931*^9, 3.475317738351663*^9}, {
   3.4753177853266783`*^9, 3.4753178479793243`*^9}, {3.4753179371284733`*^9, 
   3.475317943255937*^9}, {3.475318111011812*^9, 3.475318476083487*^9}, {
   3.475318506956699*^9, 3.475318533462604*^9}, {3.4753185995267973`*^9, 
   3.475318786548195*^9}, 3.475668020099654*^9, {3.4756689873373957`*^9, 
   3.475668993501214*^9}, {3.4756691022395363`*^9, 3.4756691484228277`*^9}, {
   3.47567007182872*^9, 3.475670154643458*^9}, {3.475671854553638*^9, 
   3.475671898233354*^9}, {3.475680704258103*^9, 3.4756807067905483`*^9}, {
   3.475681298477806*^9, 3.47568130038658*^9}, {3.475681333790805*^9, 
   3.475681348914854*^9}, {3.475682041496141*^9, 3.47568204440171*^9}, {
   3.475682395379059*^9, 3.475682448489635*^9}, {3.475682838001359*^9, 
   3.47568284541905*^9}, {3.475682895291806*^9, 3.4756829014250298`*^9}, {
   3.4756835129184504`*^9, 3.4756835190676327`*^9}, {3.475683661594532*^9, 
   3.475683665108842*^9}, {3.475683861590361*^9, 3.47568389001283*^9}, {
   3.4756840322171373`*^9, 3.4756840372960463`*^9}, {3.4756854675078697`*^9, 
   3.475685470797612*^9}, {3.475685781799308*^9, 3.475685787204969*^9}, {
   3.475685903535047*^9, 3.4756859087805767`*^9}, 3.476790506505582*^9, {
   3.476790593426433*^9, 3.4767906258556633`*^9}, {3.4767908556090517`*^9, 
   3.476790915174155*^9}, {3.476790968024768*^9, 3.476790986742021*^9}, {
   3.476791070774568*^9, 3.47679110569419*^9}, {3.476791206376417*^9, 
   3.476791270309*^9}, {3.476791308460001*^9, 3.476791352689073*^9}, {
   3.47679256733667*^9, 3.476792612411787*^9}, 3.47679264450343*^9, {
   3.4767938429343987`*^9, 3.476793843543591*^9}, {3.476793989174246*^9, 
   3.476793990315522*^9}, {3.47679572725651*^9, 3.476795730109583*^9}, {
   3.476795805506671*^9, 3.47679582197945*^9}, {3.476795992398129*^9, 
   3.4767960092534523`*^9}, {3.4767960620529413`*^9, 3.476796071680861*^9}, {
   3.476796227184114*^9, 3.47679623775878*^9}, {3.476796479017304*^9, 
   3.476796485244445*^9}, {3.476796546126347*^9, 3.4767965759482183`*^9}, {
   3.476796687615744*^9, 3.476796869916047*^9}, 3.476796953448241*^9, {
   3.4767989435880404`*^9, 3.47679898440902*^9}, {3.476799448550571*^9, 
   3.476799454457489*^9}, 3.4768081587938013`*^9, {3.476808191935524*^9, 
   3.4768081958271313`*^9}, {3.476808312215228*^9, 3.476808394438513*^9}, {
   3.47696782728123*^9, 3.476967831931374*^9}, {3.477092960869467*^9, 
   3.477092962741186*^9}, {3.4770929948198977`*^9, 3.477092996588838*^9}, {
   3.477093031370688*^9, 3.477093033174046*^9}, {3.477093063235622*^9, 
   3.477093063626453*^9}, {3.477093679346704*^9, 3.477093680306746*^9}, {
   3.47720729834219*^9, 3.477207324763942*^9}, {3.477207374451771*^9, 
   3.477207501754924*^9}, {3.4772075444512167`*^9, 3.477207597178138*^9}, {
   3.477207664084127*^9, 3.4772078319860487`*^9}, {3.4772943964474497`*^9, 
   3.477294404907754*^9}, {3.4773432991103888`*^9, 3.47734330610395*^9}, {
   3.477343350893834*^9, 3.477343403747423*^9}, {3.477369699296216*^9, 
   3.477369700829484*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Execute", " ", "the", " ", "procedure", " ", "for", " ", "Lemma", " ", 
     "3.5", " ", "by", " ", "comparing", " ", "n", " ", "and", " ", "n"}], 
    "+", 
    RowBox[{"k", " ", "step", " ", 
     RowBox[{"iterations", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Collect", " ", "initial", " ", "overlaps", " ", "by", " ", "embedding", 
    " ", "Delone", " ", "set", " ", "into", " ", "a", " ", "suitable", " ", 
    "lattice"}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"OvTwo", "=", 
     RowBox[{"{", "\[Infinity]", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Ov0", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"OvHistory", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ss0", "=", 
     RowBox[{"SessionTime", "[", "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Mes", "=", "diam"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"StA", "=", 
     RowBox[{"Union", "[", 
      RowBox[{"Nest", "[", 
       RowBox[{"Gs", ",", "St1", ",", 
        RowBox[{"Period", " ", 
         RowBox[{"Ceiling", "[", 
          RowBox[{"MinPow", "/", "Period"}], "]"}]}]}], "]"}], "]"}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"StB", "=", "St1"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"While", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "OvTwo", "]"}], "=!=", 
       RowBox[{"Length", "[", "Ov0", "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"StA", "=", 
        RowBox[{"Union", "[", 
         RowBox[{"Nest", "[", 
          RowBox[{"Gs", ",", "StA", ",", "Period"}], "]"}], "]"}]}], ";", 
       "\n", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Find", " ", "a", " ", "mesh", " ", "lattice", " ", "and", " ", 
         "embed", " ", "Delone", " ", "set", " ", "into", " ", "the", " ", 
         "lattice"}], " ", "*)"}], "\n", 
       RowBox[{"While", "[", 
        RowBox[{"True", ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"StLat", "=", 
           RowBox[{"Map", "[", 
            RowBox[{
             RowBox[{"Function", "[", 
              RowBox[{"z", ",", 
               RowBox[{"Round", "[", 
                RowBox[{
                 RowBox[{"Lat", "[", 
                  RowBox[{"z", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}], "/", "Mes"}], 
                "]"}]}], "]"}], ",", "StA"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", "StLat", "]"}], "==", 
             RowBox[{"Length", "[", 
              RowBox[{"Union", "[", "StLat", "]"}], "]"}]}], ",", 
            RowBox[{"Break", "[", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Mes", "=", 
           RowBox[{"Mes", "/", 
            RowBox[{"2", "^", 
             RowBox[{"(", 
              RowBox[{"1", "/", 
               RowBox[{"(", 
                RowBox[{"20", " ", "sz"}], ")"}]}], ")"}]}]}]}], ";"}]}], 
        "\[IndentingNewLine]", "]"}], ";", 
       RowBox[{"StLat2", "=", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"z", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{"1", ",", 
                 RowBox[{"{", "sz", "}"}]}], "]"}], "-", 
               RowBox[{"Map", "[", 
                RowBox[{"Min", ",", 
                 RowBox[{"Transpose", "[", "StLat", "]"}]}], "]"}], "+", 
               RowBox[{"Round", "[", 
                RowBox[{
                 RowBox[{"Lat", "[", 
                  RowBox[{"z", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}], "/", "Mes"}], 
                "]"}]}], ",", "z"}], "}"}]}], "]"}], ",", "StA"}], "]"}]}], 
       ";", "\n", 
       RowBox[{"StM", "=", 
        RowBox[{"Apply", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", "}"}], ",", "##"}], "]"}], "&"}], ",", 
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{"1", ",", 
               RowBox[{"{", "sz", "}"}]}], "]"}], "+", 
             RowBox[{"Map", "[", 
              RowBox[{"Max", ",", 
               RowBox[{"Transpose", "[", "StLat", "]"}]}], "]"}], "-", 
             RowBox[{"Map", "[", 
              RowBox[{"Min", ",", 
               RowBox[{"Transpose", "[", "StLat", "]"}]}], "]"}]}], ",", 
            "1"}], "]"}]}], "]"}]}], ";", "\n", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", 
          RowBox[{"Length", "[", "StLat2", "]"}]}], ",", 
         RowBox[{"i", "++"}], ",", 
         RowBox[{"StM", "=", 
          RowBox[{"ReplacePart", "[", 
           RowBox[{"StM", ",", 
            RowBox[{"Last", "[", 
             RowBox[{"StLat2", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
            RowBox[{"First", "[", 
             RowBox[{"StLat2", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "]"}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ShiftMat", "=", 
        RowBox[{"Function", "[", 
         RowBox[{"y", ",", 
          RowBox[{"Module", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"S", ",", "j", ",", "G"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"S", "=", "StM"}], ";", 
             RowBox[{"For", "[", 
              RowBox[{
               RowBox[{"j", "=", "1"}], ",", 
               RowBox[{"j", "<=", "sz"}], ",", 
               RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"G", "=", 
                 RowBox[{"Transpose", "[", 
                  RowBox[{"S", ",", 
                   RowBox[{"RotateLeft", "[", 
                    RowBox[{
                    RowBox[{"Range", "[", "sz", "]"}], ",", 
                    RowBox[{"j", "-", "1"}]}], "]"}]}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Length", "[", "G", "]"}], "<=", 
                   RowBox[{"Abs", "[", 
                    RowBox[{"y", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "]"}]}], ",", 
                  RowBox[{
                   RowBox[{"S", "=", 
                    RowBox[{"{", "}"}]}], ";", 
                   RowBox[{"Break", "[", "]"}], ";"}], ",", 
                  RowBox[{"S", "=", 
                   RowBox[{"Transpose", "[", 
                    RowBox[{
                    RowBox[{"Drop", "[", 
                    RowBox[{"G", ",", 
                    RowBox[{"y", "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"RotateLeft", "[", 
                    RowBox[{
                    RowBox[{"Range", "[", "sz", "]"}], ",", 
                    RowBox[{
                    RowBox[{"-", "j"}], "+", "1"}]}], "]"}]}], "]"}]}]}], 
                 "]"}]}]}], "]"}], ";", "S"}]}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Collect", " ", "possible", " ", "pairs", " ", "by", " ", "shifting", 
         " ", "indices", " ", "of", " ", "the", " ", "lattice"}], " ", "*)"}],
        "\[IndentingNewLine]", 
       RowBox[{"BoundList", "=", 
        RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Array", "[", 
           RowBox[{"List", ",", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"1", "+", 
               RowBox[{"Round", "[", 
                RowBox[{
                 RowBox[{"Rdm", "/", "Mes"}], "+", "1"}], "]"}], "-", 
               RowBox[{"Round", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "Rdm"}], "/", "Mes"}], "-", "1"}], "]"}]}], 
              ",", 
              RowBox[{"{", "sz", "}"}]}], "]"}], ",", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"Round", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "Rdm"}], "/", "Mes"}], "-", "1"}], "]"}], ",", 
              RowBox[{"{", "sz", "}"}]}], "]"}]}], "]"}], ",", 
          RowBox[{"sz", "-", "1"}]}], "]"}]}], ";", "\n", 
       RowBox[{"OvHistory", "=", 
        RowBox[{"Append", "[", 
         RowBox[{"OvHistory", ",", 
          RowBox[{"Length", "[", "Ov0", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Ov0", "=", 
        RowBox[{"{", 
         RowBox[{"{", "}"}], "}"}]}], ";", "\n", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"k", "=", "1"}], ",", 
         RowBox[{"k", "\[LessEqual]", 
          RowBox[{"Length", "[", "BoundList", "]"}]}], ",", 
         RowBox[{"k", "++"}], ",", 
         RowBox[{
          RowBox[{"SB", "=", 
           RowBox[{"ShiftMat", "[", 
            RowBox[{"BoundList", "[", 
             RowBox[{"[", "k", "]"}], "]"}], "]"}]}], ";", "\n", 
          RowBox[{"Ov0", "=", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"SB", "==", 
              RowBox[{"{", "}"}]}], ",", "Ov0", ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Ov0", "=", 
               RowBox[{"Union", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"{", "}"}], "}"}], ",", "Ov0", ",", 
                 RowBox[{"Map", "[", 
                  RowBox[{
                   RowBox[{"Function", "[", 
                    RowBox[{"z", ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"{", "}"}]}], " ", "||", " ", 
                    RowBox[{
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"{", "}"}]}]}], ",", 
                    RowBox[{"{", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"First", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"Last", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", 
                    RowBox[{"Last", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"First", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
                     "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Flatten", "[", 
                    RowBox[{
                    RowBox[{"MapThread", "[", 
                    RowBox[{"List", ",", 
                    RowBox[{"{", 
                    RowBox[{"SB", ",", 
                    RowBox[{"ShiftMat", "[", 
                    RowBox[{"-", 
                    RowBox[{"BoundList", "[", 
                    RowBox[{"[", "k", "]"}], "]"}]}], "]"}]}], "}"}], ",", 
                    "sz"}], "]"}], ",", 
                    RowBox[{"sz", "-", "1"}]}], "]"}]}], "]"}]}], "]"}]}], 
              ";", "\[IndentingNewLine]", 
              RowBox[{"Ov0", "=", 
               RowBox[{"Select", "[", 
                RowBox[{
                 RowBox[{"Drop", "[", 
                  RowBox[{"Ov0", ",", "1"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Norm", "[", 
                    RowBox[{
                    RowBox[{"Lat", "[", 
                    RowBox[{"N", "[", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "]"}], ",", "2"}], 
                    "]"}], "\[LessEqual]", "Rdm"}], ")"}], "&"}]}], 
                "]"}]}]}]}], "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "OvHistory", "]"}], ">", 
          RowBox[{"Ceiling", "[", 
           RowBox[{"MinPow", "/", "Period"}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"OvTwo", "=", 
           RowBox[{"Table", "[", 
            RowBox[{"0", ",", 
             RowBox[{"{", 
              RowBox[{"OvHistory", "[", 
               RowBox[{"[", 
                RowBox[{"-", 
                 RowBox[{"Ceiling", "[", 
                  RowBox[{"MinPow", "/", "Period"}], "]"}]}], "]"}], "]"}], 
              "}"}]}], "]"}]}], ";", 
          RowBox[{"Goto", "[", "Jump", "]"}]}]}], "]"}], ";", "\n", 
       RowBox[{"StB", "=", 
        RowBox[{"Union", "[", 
         RowBox[{"Nest", "[", 
          RowBox[{"Gs", ",", "StB", ",", "Period"}], "]"}], "]"}]}], ";", 
       "\n", 
       RowBox[{"StLat2", "=", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"z", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{"1", ",", 
                 RowBox[{"{", "sz", "}"}]}], "]"}], "-", 
               RowBox[{"Map", "[", 
                RowBox[{"Min", ",", 
                 RowBox[{"Transpose", "[", "StLat", "]"}]}], "]"}], "+", 
               RowBox[{"Round", "[", 
                RowBox[{
                 RowBox[{"Lat", "[", 
                  RowBox[{"z", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}], "/", "Mes"}], 
                "]"}]}], ",", "z"}], "}"}]}], "]"}], ",", "StB"}], "]"}]}], 
       ";", "\n", 
       RowBox[{"StM", "=", 
        RowBox[{"Apply", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", "}"}], ",", "##"}], "]"}], "&"}], ",", 
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{"1", ",", 
               RowBox[{"{", "sz", "}"}]}], "]"}], "+", 
             RowBox[{"Map", "[", 
              RowBox[{"Max", ",", 
               RowBox[{"Transpose", "[", "StLat", "]"}]}], "]"}], "-", 
             RowBox[{"Map", "[", 
              RowBox[{"Min", ",", 
               RowBox[{"Transpose", "[", "StLat", "]"}]}], "]"}]}], ",", 
            "1"}], "]"}]}], "]"}]}], ";", "\n", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", 
          RowBox[{"Length", "[", "StLat2", "]"}]}], ",", 
         RowBox[{"i", "++"}], ",", 
         RowBox[{"StM", "=", 
          RowBox[{"ReplacePart", "[", 
           RowBox[{"StM", ",", 
            RowBox[{"Last", "[", 
             RowBox[{"StLat2", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
            RowBox[{"First", "[", 
             RowBox[{"StLat2", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "]"}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ShiftMatB", "=", 
        RowBox[{"Function", "[", 
         RowBox[{"y", ",", 
          RowBox[{"Module", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"S", ",", "j", ",", "G"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"S", "=", "StM"}], ";", 
             RowBox[{"For", "[", 
              RowBox[{
               RowBox[{"j", "=", "1"}], ",", 
               RowBox[{"j", "<=", "sz"}], ",", 
               RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"G", "=", 
                 RowBox[{"Transpose", "[", 
                  RowBox[{"S", ",", 
                   RowBox[{"RotateLeft", "[", 
                    RowBox[{
                    RowBox[{"Range", "[", "sz", "]"}], ",", 
                    RowBox[{"j", "-", "1"}]}], "]"}]}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Length", "[", "G", "]"}], "<=", 
                   RowBox[{"Abs", "[", 
                    RowBox[{"y", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "]"}]}], ",", 
                  RowBox[{
                   RowBox[{"S", "=", 
                    RowBox[{"{", "}"}]}], ";", 
                   RowBox[{"Break", "[", "]"}], ";"}], ",", 
                  RowBox[{"S", "=", 
                   RowBox[{"Transpose", "[", 
                    RowBox[{
                    RowBox[{"Drop", "[", 
                    RowBox[{"G", ",", 
                    RowBox[{"y", "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"RotateLeft", "[", 
                    RowBox[{
                    RowBox[{"Range", "[", "sz", "]"}], ",", 
                    RowBox[{
                    RowBox[{"-", "j"}], "+", "1"}]}], "]"}]}], "]"}]}]}], 
                 "]"}]}]}], "]"}], ";", "S"}]}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Collect", " ", "possible", " ", "pairs", " ", "by", " ", "shifting", 
         " ", "indices", " ", "of", " ", "the", " ", "lattice"}], " ", "*)"}],
        "\[IndentingNewLine]", 
       RowBox[{"BoundList", "=", 
        RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Array", "[", 
           RowBox[{"List", ",", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"1", "+", 
               RowBox[{"Round", "[", 
                RowBox[{
                 RowBox[{"Rdm", "/", "Mes"}], "+", "1"}], "]"}], "-", 
               RowBox[{"Round", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "Rdm"}], "/", "Mes"}], "-", "1"}], "]"}]}], 
              ",", 
              RowBox[{"{", "sz", "}"}]}], "]"}], ",", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"Round", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "Rdm"}], "/", "Mes"}], "-", "1"}], "]"}], ",", 
              RowBox[{"{", "sz", "}"}]}], "]"}]}], "]"}], ",", 
          RowBox[{"sz", "-", "1"}]}], "]"}]}], ";", "\n", 
       RowBox[{"OvTwo", "=", 
        RowBox[{"{", 
         RowBox[{"{", "}"}], "}"}]}], ";", "\n", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"k", "=", "1"}], ",", 
         RowBox[{"k", "\[LessEqual]", 
          RowBox[{"Length", "[", "BoundList", "]"}]}], ",", 
         RowBox[{"k", "++"}], ",", 
         RowBox[{
          RowBox[{"SB", "=", 
           RowBox[{"ShiftMatB", "[", 
            RowBox[{"BoundList", "[", 
             RowBox[{"[", "k", "]"}], "]"}], "]"}]}], ";", "\n", 
          RowBox[{"OvTwo", "=", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"SB", "==", 
              RowBox[{"{", "}"}]}], ",", "OvTwo", ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"OvTwo", "=", 
               RowBox[{"Union", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"{", "}"}], "}"}], ",", "OvTwo", ",", 
                 RowBox[{"Map", "[", 
                  RowBox[{
                   RowBox[{"Function", "[", 
                    RowBox[{"z", ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"{", "}"}]}], " ", "||", " ", 
                    RowBox[{
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"{", "}"}]}]}], ",", 
                    RowBox[{"{", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"First", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"Last", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", 
                    RowBox[{"Last", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"First", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
                     "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Flatten", "[", 
                    RowBox[{
                    RowBox[{"MapThread", "[", 
                    RowBox[{"List", ",", 
                    RowBox[{"{", 
                    RowBox[{"SB", ",", 
                    RowBox[{"ShiftMatB", "[", 
                    RowBox[{"-", 
                    RowBox[{"BoundList", "[", 
                    RowBox[{"[", "k", "]"}], "]"}]}], "]"}]}], "}"}], ",", 
                    "sz"}], "]"}], ",", 
                    RowBox[{"sz", "-", "1"}]}], "]"}]}], "]"}]}], "]"}]}], 
              ";", "\[IndentingNewLine]", 
              RowBox[{"OvTwo", "=", 
               RowBox[{"Select", "[", 
                RowBox[{
                 RowBox[{"Drop", "[", 
                  RowBox[{"OvTwo", ",", "1"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Norm", "[", 
                    RowBox[{
                    RowBox[{"Lat", "[", 
                    RowBox[{"N", "[", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "]"}], ",", "2"}], 
                    "]"}], "\[LessEqual]", "Rdm"}], ")"}], "&"}]}], 
                "]"}]}]}]}], "]"}]}], ";"}]}], "\n", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Label", "[", "Jump", "]"}], ";", "\n", 
       RowBox[{"Print", "[", 
        RowBox[{"rp", ",", "\"\< \>\"", ",", 
         RowBox[{"Length", "[", "OvTwo", "]"}], ",", "\"\< \>\"", ",", 
         RowBox[{"Length", "[", "Ov0", "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"rp", "++"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
   "\n", 
   RowBox[{
    RowBox[{"rt2", "=", 
     RowBox[{"Map", "[", 
      RowBox[{"Lat", ",", "rt1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Ov", "=", 
     RowBox[{"{", 
      RowBox[{"{", "}"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Collect", " ", "possible", " ", "pairs", " ", "by", " ", "shifting", " ",
      "indices", " ", "of", " ", "the", " ", "lattice"}], " ", "*)"}], "\n", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", "1"}], ",", 
      RowBox[{"i", "\[LessEqual]", "sz"}], ",", 
      RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"BoundList2", "=", 
        RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Array", "[", 
           RowBox[{"List", ",", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"1", "+", 
               RowBox[{"Round", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"rt2", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j"}], "]"}], "]"}], "+", "diam"}], 
                   ")"}], "/", "Mes"}], "+", "1"}], "]"}], "-", 
               RowBox[{"Round", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"rt2", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j"}], "]"}], "]"}], "-", "diam"}], 
                   ")"}], "/", "Mes"}], "-", "1"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"j", ",", "1", ",", "sz"}], "}"}]}], "]"}], ",", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"Round", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"rt2", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j"}], "]"}], "]"}], "-", "diam"}], 
                  ")"}], "/", "Mes"}], "-", "1"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"j", ",", "1", ",", "sz"}], "}"}]}], "]"}]}], "]"}], 
          ",", 
          RowBox[{"sz", "-", "1"}]}], "]"}]}], ";", "\n", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"k", "=", "1"}], ",", 
         RowBox[{"k", "\[LessEqual]", 
          RowBox[{"Length", "[", "BoundList2", "]"}]}], ",", 
         RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Ov", "=", 
           RowBox[{"Union", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"{", "}"}], "}"}], ",", "Ov", ",", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{"Function", "[", 
                RowBox[{"z", ",", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"{", "}"}]}], " ", "||", " ", 
                    RowBox[{
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"{", "}"}]}]}], ",", 
                   RowBox[{"{", "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"First", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"Last", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", 
                    RowBox[{"rt1", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "-", 
                    RowBox[{"Last", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"First", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
                 "]"}], ",", 
               RowBox[{"Flatten", "[", 
                RowBox[{
                 RowBox[{"MapThread", "[", 
                  RowBox[{"List", ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ShiftMat", "[", 
                    RowBox[{"BoundList2", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"ShiftMat", "[", 
                    RowBox[{"-", 
                    RowBox[{"BoundList2", "[", 
                    RowBox[{"[", "k", "]"}], "]"}]}], "]"}]}], "}"}], ",", 
                   "sz"}], "]"}], ",", 
                 RowBox[{"sz", "-", "1"}]}], "]"}]}], "]"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Ov", "=", 
           RowBox[{"Select", "[", 
            RowBox[{
             RowBox[{"Drop", "[", 
              RowBox[{"Ov", ",", "1"}], "]"}], ",", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Norm", "[", 
                 RowBox[{
                  RowBox[{"Lat", "[", 
                   RowBox[{"N", "[", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "]"}], ",", "2"}], 
                 "]"}], "\[LessEqual]", "diam"}], ")"}], "&"}]}], "]"}]}], 
          ";"}]}], "\[IndentingNewLine]", "]"}]}]}], "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<# of initial overlaps \>\"", ",", 
      RowBox[{"Length", "[", "Ov", "]"}]}], "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Main routine took \>\"", ",", 
      RowBox[{
       RowBox[{"SessionTime", "[", "]"}], "-", "ss0"}], ",", " ", 
      "\"\< seconds\>\""}], "]"}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.474088908617284*^9, 3.4740889305620127`*^9}, {
   3.474089658355164*^9, 3.4740897197950706`*^9}, {3.474089845275303*^9, 
   3.4740898780417557`*^9}, {3.4741635286976223`*^9, 3.474163759156497*^9}, {
   3.474272142089034*^9, 3.474272159403861*^9}, {3.475042918182651*^9, 
   3.475042921413987*^9}, {3.475046464614616*^9, 3.475046467104745*^9}, {
   3.475254883574643*^9, 3.475254904467121*^9}, {3.475255015694975*^9, 
   3.4752550571536293`*^9}, {3.4753170799134703`*^9, 3.475317199265299*^9}, {
   3.4753172334012823`*^9, 3.475317358524674*^9}, {3.475317401531005*^9, 
   3.475317651618528*^9}, {3.475317736426931*^9, 3.475317738351663*^9}, {
   3.4753177853266783`*^9, 3.4753178479793243`*^9}, {3.4753179371284733`*^9, 
   3.475317943255937*^9}, {3.475318111011812*^9, 3.475318476083487*^9}, {
   3.475318506956699*^9, 3.475318533462604*^9}, {3.4753185995267973`*^9, 
   3.475318786548195*^9}, 3.475668020099654*^9, {3.4756689873373957`*^9, 
   3.475668993501214*^9}, {3.4756691022395363`*^9, 3.4756691484228277`*^9}, {
   3.47567007182872*^9, 3.475670154643458*^9}, {3.475671854553638*^9, 
   3.475671898233354*^9}, {3.475680704258103*^9, 3.4756807067905483`*^9}, {
   3.475681298477806*^9, 3.47568130038658*^9}, {3.475681333790805*^9, 
   3.475681348914854*^9}, {3.475682041496141*^9, 3.47568204440171*^9}, {
   3.475682395379059*^9, 3.475682448489635*^9}, {3.475682838001359*^9, 
   3.47568284541905*^9}, {3.475682895291806*^9, 3.4756829014250298`*^9}, {
   3.4756835129184504`*^9, 3.4756835190676327`*^9}, {3.475683661594532*^9, 
   3.475683665108842*^9}, {3.475683861590361*^9, 3.47568389001283*^9}, {
   3.4756840322171373`*^9, 3.4756840372960463`*^9}, {3.4756854675078697`*^9, 
   3.475685470797612*^9}, {3.475685781799308*^9, 3.475685787204969*^9}, {
   3.475685903535047*^9, 3.4756859087805767`*^9}, 3.476790506505582*^9, {
   3.476790593426433*^9, 3.4767906258556633`*^9}, {3.4767908556090517`*^9, 
   3.476790915174155*^9}, {3.476790968024768*^9, 3.476790986742021*^9}, {
   3.476791070774568*^9, 3.47679110569419*^9}, {3.476791206376417*^9, 
   3.476791270309*^9}, {3.476791308460001*^9, 3.476791352689073*^9}, {
   3.47679256733667*^9, 3.476792612411787*^9}, 3.47679264450343*^9, {
   3.4767938429343987`*^9, 3.476793843543591*^9}, {3.476793989174246*^9, 
   3.476793990315522*^9}, {3.47679572725651*^9, 3.476795730109583*^9}, {
   3.476795805506671*^9, 3.47679582197945*^9}, {3.476795992398129*^9, 
   3.4767960092534523`*^9}, {3.4767960620529413`*^9, 3.476796071680861*^9}, {
   3.476796227184114*^9, 3.47679623775878*^9}, {3.476796479017304*^9, 
   3.476796485244445*^9}, {3.476796546126347*^9, 3.4767965759482183`*^9}, {
   3.476796687615744*^9, 3.476796869916047*^9}, 3.476796953448241*^9, {
   3.4767989435880404`*^9, 3.47679898440902*^9}, {3.476799448550571*^9, 
   3.476799454457489*^9}, 3.4768081587938013`*^9, {3.476808191935524*^9, 
   3.4768081958271313`*^9}, {3.476808229961055*^9, 3.4768082842819357`*^9}, 
   3.476808859387158*^9, {3.476855385921279*^9, 3.476855438641677*^9}, {
   3.47685614114977*^9, 3.476856149194414*^9}, {3.476856338736335*^9, 
   3.4768563612468233`*^9}, {3.476857031411188*^9, 3.476857032777465*^9}, {
   3.476968088781742*^9, 3.476968091940023*^9}, {3.4770937548528337`*^9, 
   3.47709376269063*^9}, {3.4770938427111473`*^9, 3.477093852358199*^9}, {
   3.477094109872126*^9, 3.477094143634692*^9}, {3.477289700244063*^9, 
   3.477289705585338*^9}, {3.4772900176321087`*^9, 3.4772900381330442`*^9}, {
   3.47729021282619*^9, 3.4772902232598743`*^9}, 3.477290288392325*^9, {
   3.477294511661399*^9, 3.47729451333113*^9}, {3.4772945588778276`*^9, 
   3.477294574783895*^9}, 3.47729461571966*^9, {3.477294676748621*^9, 
   3.477294700930621*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Overlap", " ", "Inflation", " ", "function"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Rl1", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{"Function", "[", 
            RowBox[{"z1", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"z1", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"Q", ".", 
                 RowBox[{"z", "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "+", 
                RowBox[{
                 RowBox[{"z1", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "-", 
                RowBox[{
                 RowBox[{"z1", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], ",", 
               RowBox[{
                RowBox[{"z1", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}], ",", 
           RowBox[{"Flatten", "[", 
            RowBox[{
             RowBox[{"Outer", "[", 
              RowBox[{"List", ",", 
               RowBox[{"Rl0", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"First", "[", "z", "]"}], "+", "1"}], "]"}], "]"}], 
               ",", 
               RowBox[{"Rl0", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"Last", "[", "z", "]"}], "+", "1"}], "]"}], "]"}], 
               ",", "1"}], "]"}], ",", "1"}], "]"}], ",", "1"}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"Norm", "[", 
            RowBox[{
             RowBox[{"Lat", "[", 
              RowBox[{"#", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", "2"}], "]"}], 
           "\[LessEqual]", "diam"}], "&"}]}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Overlap", " ", "algorithm"}], " ", "*)"}], "\n", 
   RowBox[{
    RowBox[{"Inf", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Union", "[", 
        RowBox[{"Join", "[", 
         RowBox[{"z", ",", 
          RowBox[{"Flatten", "[", 
           RowBox[{
            RowBox[{"Map", "[", 
             RowBox[{"Rl1", ",", "z"}], "]"}], ",", "1"}], "]"}]}], "]"}], 
        "]"}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Ov1", "=", 
     RowBox[{"NestWhile", "[", 
      RowBox[{"Inf", ",", "Ov", ",", "UnsameQ", ",", "All"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<# of stable overlaps under inflation: \>\"", ",", 
      RowBox[{"Length", "[", "Ov1", "]"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Overlap", " ", "graph"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Og", "=", 
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{"Function", "[", 
          RowBox[{"z", ",", 
           RowBox[{"Map", "[", 
            RowBox[{
             RowBox[{"Function", "[", 
              RowBox[{"x", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"z", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", "x"}], "}"}]}], "]"}], 
             ",", 
             RowBox[{"z", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], "]"}], ",", 
         RowBox[{"MapThread", "[", 
          RowBox[{"List", ",", 
           RowBox[{"{", 
            RowBox[{"Ov1", ",", 
             RowBox[{"Map", "[", 
              RowBox[{"Rl1", ",", "Ov1"}], "]"}]}], "}"}]}], "]"}]}], "]"}], 
       ",", "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Construct", " ", "and", " ", "draw", " ", "the", " ", "graph"}], 
    " ", "*)"}], "\n", 
   RowBox[{
    RowBox[{"Ov2", "=", 
     RowBox[{"Union", "[", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Og", ",", "1"}], "]"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"gr0", "=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{"Function", "[", 
        RowBox[{"z", ",", 
         RowBox[{
          RowBox[{"z", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", 
          RowBox[{"z", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ",", 
       RowBox[{"MapThread", "[", 
        RowBox[{"List", ",", 
         RowBox[{"{", 
          RowBox[{"Ov2", ",", 
           RowBox[{"Range", "[", 
            RowBox[{"Length", "[", "Ov2", "]"}], "]"}]}], "}"}]}], "]"}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"g", "=", 
     RowBox[{"FromOrderedPairs", "[", 
      RowBox[{"Og", "/.", "gr0"}], "]"}]}], ";"}], "\n", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Delete", " ", "vertices", " ", "without", " ", "outgoing", " ", 
     "edges"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"LL", "=", "\[Infinity]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"While", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "Ov2", "]"}], "<", "LL"}], ",", 
      RowBox[{
       RowBox[{"LL", "=", 
        RowBox[{"Length", "[", "Ov2", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Ov2", "=", 
        RowBox[{"Delete", "[", 
         RowBox[{"Ov2", ",", 
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"OutDegree", "[", "g", "]"}], ",", "0"}], "]"}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"g", "=", 
        RowBox[{"InduceSubgraph", "[", 
         RowBox[{"g", ",", 
          RowBox[{"Flatten", "[", 
           RowBox[{"Position", "[", 
            RowBox[{
             RowBox[{"OutDegree", "[", "g", "]"}], ",", 
             RowBox[{"_", "?", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"#", ">", "0"}], "&"}], ")"}]}]}], "]"}], "]"}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"Length", "[", "Ov2", "]"}], "]"}]}]}], "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Size of potential overlap graph : \>\"", ",", 
      RowBox[{"Length", "[", "Ov2", "]"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "Ov2", "]"}], "<", "100"}], ",", 
       RowBox[{"ShowGraph", "[", 
        RowBox[{"SpringEmbedding", "[", 
         RowBox[{"g", ",", "200", ",", "0.1"}], "]"}], "]"}]}], "]"}], ";"}], 
    " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Pick", " ", "out", " ", "all", " ", "coincidences"}], " ", 
    "*)"}], "\n", 
   RowBox[{
    RowBox[{"Ci", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", "1"}], ",", 
      RowBox[{"i", "\[LessEqual]", 
       RowBox[{"Length", "[", "Ov2", "]"}]}], ",", 
      RowBox[{"i", "++"}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"First", "[", 
           RowBox[{"Ov2", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "]"}], "\[Equal]", 
          RowBox[{"Last", "[", 
           RowBox[{"Ov2", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "&&", 
         RowBox[{
          RowBox[{
           RowBox[{"Ov2", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
          RowBox[{"Table", "[", 
           RowBox[{"0", ",", 
            RowBox[{"{", "sz", "}"}]}], "]"}]}]}], ",", 
        RowBox[{"Ci", "=", 
         RowBox[{"Append", "[", 
          RowBox[{"Ci", ",", "i"}], "]"}]}]}], "]"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"Ci", "\[Equal]", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{
       RowBox[{
       "Print", "[", "\"\<Data Error: Trivial coincidences not found.\>\"", 
        "]"}], ";", 
       RowBox[{"Interrupt", "[", "]"}], ";"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Vertices", " ", "which", " ", "do", " ", "not", " ", "lead", " ", "to", 
     " ", "a", " ", 
     RowBox[{"coincidence", "."}]}], "*)"}], "\n", 
   RowBox[{
    RowBox[{"Bd", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Tg", "=", 
     RowBox[{"ToAdjacencyMatrix", "[", 
      RowBox[{"TransitiveClosure", "[", "g", "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Much", " ", "faster", " ", "than", " ", "using", " ", "shortest", " ", 
     "path", " ", "function"}], " ", "*)"}], "\n", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"j", "=", "1"}], ",", 
      RowBox[{"j", "\[LessEqual]", 
       RowBox[{"Length", "[", "Ov2", "]"}]}], ",", 
      RowBox[{"j", "++"}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Max", "[", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Tg", "[", 
              RowBox[{"[", 
               RowBox[{"j", ",", "#"}], "]"}], "]"}], "&"}], ",", "Ci"}], 
           "]"}], "]"}], "\[Equal]", "0"}], ",", 
        RowBox[{"Bd", "=", 
         RowBox[{"Append", "[", 
          RowBox[{"Bd", ",", "j"}], "]"}]}]}], "]"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Delete", " ", "coincidences", " ", "which", " ", "might", " ", "appear", 
     " ", "in", " ", 
     RowBox[{"Bd", ".", " ", "In"}], " ", "practice", " ", "it", " ", "never",
      " ", 
     RowBox[{"appears", "."}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Bd", "=", 
     RowBox[{"Complement", "[", 
      RowBox[{"Bd", ",", "Ci"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Color used for computation \>\"", ",", "col"}], "]"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Return Vector \>\"", ",", "rt1"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<# of overlaps leading to coincidence = \>\"", ",", 
      RowBox[{
       RowBox[{"Length", "[", "Ov2", "]"}], "-", 
       RowBox[{"Length", "[", "Bd", "]"}]}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<# of non coincidence potential overlaps = \>\"", ",", 
      RowBox[{"Length", "[", "Bd", "]"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{"(*", " ", 
    RowBox[{"Compare", " ", 
     RowBox[{"spectra", ":", 
      RowBox[{
      "Use", " ", "approximation", " ", "to", " ", "avoid", " ", "algebraic", 
       " ", "computation", " ", "of", " ", "spectra"}]}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "Bd", "]"}], ">", "0"}], ",", 
      RowBox[{
       RowBox[{"Print", "[", 
        RowBox[{"\"\<Spectral Radius = \>\"", ",", 
         RowBox[{"Rd1", "=", 
          RowBox[{"Max", "[", 
           RowBox[{"Abs", "[", 
            RowBox[{"Eigenvalues", "[", 
             RowBox[{
              RowBox[{"ToAdjacencyMatrix", "[", "g", "]"}], "//", "N"}], 
             "]"}], "]"}], "]"}]}], ",", "\"\<,  PF eigenvalue = \>\"", ",", 
         RowBox[{"Max", "[", 
          RowBox[{"Abs", "[", 
           RowBox[{"Eg", "//", "N"}], "]"}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{
        "\"\<Radius of induced graph from non coincidence overlaps = \>\"", 
         ",", 
         RowBox[{"Rd2", "=", 
          RowBox[{"Max", "[", 
           RowBox[{"Abs", "[", 
            RowBox[{"Eigenvalues", "[", 
             RowBox[{
              RowBox[{"ToAdjacencyMatrix", "[", 
               RowBox[{"InduceSubgraph", "[", 
                RowBox[{"g", ",", "Bd"}], "]"}], "]"}], "//", "N"}], "]"}], 
            "]"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"Rd2", "<", "Rd1"}], ",", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<Coincidence\>\"", "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<Hausdorff dimension of the boundary w.r.t. pseudo norm = \
\>\"", ",", 
            RowBox[{
             RowBox[{"sz", " ", 
              RowBox[{
               RowBox[{"Log", "[", "Rd2", "]"}], "/", 
               RowBox[{"Log", "[", "Rd1", "]"}]}]}], "//", "N"}]}], "]"}]}], 
         "\[IndentingNewLine]", ",", 
         RowBox[{"Print", "[", "\"\<No Coincidence \>\"", "]"}]}], "]"}]}], 
      ",", 
      RowBox[{"Print", "[", "\"\<No edge overlap found\>\"", "]"}]}], "]"}], 
    ";"}]}]}]], "Input",
 CellChangeTimes->{{3.474088908617284*^9, 3.4740889305620127`*^9}, {
   3.474089658355164*^9, 3.4740897197950706`*^9}, {3.474089845275303*^9, 
   3.4740898780417557`*^9}, {3.4741635286976223`*^9, 3.474163759156497*^9}, {
   3.474272142089034*^9, 3.474272159403861*^9}, {3.475042918182651*^9, 
   3.475042921413987*^9}, {3.475046464614616*^9, 3.475046467104745*^9}, {
   3.475254883574643*^9, 3.475254904467121*^9}, {3.475255015694975*^9, 
   3.4752550571536293`*^9}, {3.4753170799134703`*^9, 3.475317199265299*^9}, {
   3.4753172334012823`*^9, 3.475317358524674*^9}, {3.475317401531005*^9, 
   3.475317651618528*^9}, {3.475317736426931*^9, 3.475317738351663*^9}, {
   3.4753177853266783`*^9, 3.4753178479793243`*^9}, {3.4753179371284733`*^9, 
   3.475317943255937*^9}, {3.475318111011812*^9, 3.475318476083487*^9}, {
   3.475318506956699*^9, 3.475318533462604*^9}, {3.4753185995267973`*^9, 
   3.475318786548195*^9}, 3.475668020099654*^9, {3.4756689873373957`*^9, 
   3.475668993501214*^9}, {3.4756691022395363`*^9, 3.4756691484228277`*^9}, {
   3.47567007182872*^9, 3.475670154643458*^9}, {3.475671854553638*^9, 
   3.475671898233354*^9}, {3.475680704258103*^9, 3.4756807067905483`*^9}, {
   3.475681298477806*^9, 3.47568130038658*^9}, {3.475681333790805*^9, 
   3.475681348914854*^9}, {3.475682041496141*^9, 3.47568204440171*^9}, {
   3.475682395379059*^9, 3.475682448489635*^9}, {3.475682838001359*^9, 
   3.47568284541905*^9}, {3.475682895291806*^9, 3.4756829014250298`*^9}, {
   3.4756835129184504`*^9, 3.4756835190676327`*^9}, {3.475683661594532*^9, 
   3.475683665108842*^9}, {3.475683861590361*^9, 3.47568389001283*^9}, {
   3.4756840322171373`*^9, 3.4756840372960463`*^9}, {3.4756854675078697`*^9, 
   3.475685470797612*^9}, {3.475685781799308*^9, 3.475685787204969*^9}, {
   3.475685903535047*^9, 3.4756859087805767`*^9}, 3.476790506505582*^9, {
   3.476790593426433*^9, 3.4767906258556633`*^9}, {3.4767908556090517`*^9, 
   3.476790915174155*^9}, {3.476790968024768*^9, 3.476790986742021*^9}, {
   3.476791070774568*^9, 3.47679110569419*^9}, {3.476791206376417*^9, 
   3.476791270309*^9}, {3.476791308460001*^9, 3.476791352689073*^9}, {
   3.47679256733667*^9, 3.476792612411787*^9}, 3.47679264450343*^9, {
   3.4767938429343987`*^9, 3.476793843543591*^9}, {3.476793989174246*^9, 
   3.476793990315522*^9}, {3.47679572725651*^9, 3.476795730109583*^9}, {
   3.476795805506671*^9, 3.47679582197945*^9}, {3.476795992398129*^9, 
   3.4767960092534523`*^9}, {3.4767960620529413`*^9, 3.476796071680861*^9}, {
   3.476796227184114*^9, 3.47679623775878*^9}, {3.476796479017304*^9, 
   3.476796485244445*^9}, {3.476796546126347*^9, 3.4767965759482183`*^9}, {
   3.476796687615744*^9, 3.476796869916047*^9}, 3.476796953448241*^9, {
   3.4767989435880404`*^9, 3.47679898440902*^9}, {3.476799448550571*^9, 
   3.476799454457489*^9}, 3.4768081587938013`*^9, {3.476808191935524*^9, 
   3.4768081958271313`*^9}, {3.476808229961055*^9, 3.4768082842819357`*^9}, 
   3.476808859387158*^9, {3.476855385921279*^9, 3.4768554007902412`*^9}, {
   3.4770941783607893`*^9, 3.477094249862455*^9}, 3.4772079291363907`*^9, {
   3.477208062569483*^9, 3.477208070167589*^9}, {3.484622119716717*^9, 
   3.484622125751275*^9}, 3.492853619481691*^9}]
},
WindowToolbars->"EditBar",
WindowSize->{1018, 706},
WindowMargins->{{-2, 2}, {2, Automatic}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic},
Magnification->1,
FrontEndVersion->"7.0 for Linux x86 (64-bit) (December 18, 2008)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 60700, 1649, 3575, "Input"],
Cell[61248, 1671, 8196, 191, 385, "Input"],
Cell[69447, 1864, 11111, 249, 759, "Input"],
Cell[80561, 2115, 18219, 466, 1067, "Input"],
Cell[98783, 2583, 11169, 243, 473, "Input"],
Cell[109955, 2828, 10077, 218, 429, "Input"],
Cell[120035, 3048, 8805, 183, 495, "Input"],
Cell[128843, 3233, 20347, 518, 1265, "Input"],
Cell[149193, 3753, 32683, 770, 1793, "Input"],
Cell[181879, 4525, 16617, 413, 1133, "Input"]
}
]
*)

(* End of internal cache information *)
